<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @license    http://www.simploo.de
 * @version    $Id: BackupController.php 1433 2010-06-17 10:17:46Z ms $
 */
class Sicore_BackupController extends Sicore_Controllers_Simploo
{
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('dblist', 'json');
        $this->_helper->contextSwitch()->addActionContext('dbbackup', 'json'); 
        parent::init();
    }
    
    public function dblistAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();
        
        $dir       = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp/');
        if(file_exists($dir.'backup.sql')){
            $this->view->backups = array();
            $this->view->backups[0]['name'] = 'backup.sql';
            $this->view->backups[0]['size'] = Sicore_Models_Helper_FSO::filesize($dir.'backup.sql');
            $date = new Zend_Date(filemtime($dir.'backup.sql'));
            $this->view->backups[0]['date'] = $date->get(Zend_Date::DATE_LONG).", ".$date->get(Zend_Date::TIME_MEDIUM).' Uhr';
        }
        $data['button1']['label']   = $translate->_('BACKUP_DB_START');
        $data['button1']['onclick'] = 'si_menu_settings_dbbackup()'; 
       
        $data['content'] = $this->view->render('settings/backups/database.phtml');
        $data['title']   = $translate->_('BACKUP_DB');
        echo Zend_Json::encode($data);
        die();
    }
    
    public function dbbackupAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();
        
        $dir        = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp/');   
           
        $mBackup = new Sicore_Models_Server_Db_Backup();
        if(!$mBackup->start($dir.'backup.sql')){
            $data['status']    = false;
            $data['msg_title'] = $translate->_('BACKUP_DB_START');
            $data['msg_text']  = $translate->_('BACKUP_DB_FAILED');
            echo Zend_Json::encode($data);
            die(); 
        }
        
        $data['status']    = true;
        $data['msg_title'] = $translate->_('BACKUP_DB_START');
        $data['msg_text']  = $translate->_('BACKUP_DB_OK');
        echo Zend_Json::encode($data);
        die(); 
    }
    
    public function dbrestoreAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();
        
        $dir        = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp/');   
           
        $mBackup = new Sicore_Models_Server_Db_Backup();
        if(!$mBackup->restore($dir.'backup.sql')){
            $data['status']    = false;
            $data['msg_title'] = $translate->_('BACKUP_DB_RESTORE');
            $data['msg_text']  = $translate->_('BACKUP_DB_RESTORE_FAILED');
            echo Zend_Json::encode($data);
            die(); 
        }
        
        $data['status']    = true;
        $data['msg_title'] = $translate->_('BACKUP_DB_RESTORE');
        $data['msg_text']  = $translate->_('BACKUP_DB_RESTORE_OK');
        echo Zend_Json::encode($data);
        die(); 
    }
    
    public function dbdownloadAction()
    {

        $dir      = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp/');  
        $backup   = $dir.'backup.sql';
        $date     = new Zend_Date(filemtime($dir.'backup.sql'));
        $date     = str_replace('.', '', $date->get(Zend_Date::DATE_SHORT));
        
        header("HTTP/1.1 200 OK");
        header("Content-Type: application/force-download");
        header('Content-Disposition: attachment; filename="backup_'.$date.'.sql"');
        header("Content-Transfer-Encoding: binary");
        readfile($backup) ;  
        die();
    }
    
}