<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: ClipboardController.php 1504 2010-08-17 16:35:17Z ms $
 */
class Sicore_ClipboardController extends Sicore_Controllers_Simploo
{
    
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('addpage',       'json');
        $this->_helper->contextSwitch()->addActionContext('addcontent',    'json'); 
        
        parent::init();
    }
    
    public function addpageAction()
    {
        $uid       = intval($this->getRequest()->getParam('uid'));
        $name      = base64_decode($this->getRequest()->getParam('name'));
        
        if($uid){
            $clipboard = Sicore_Models_Clipboard::addPage($uid, $name);
        }
        echo Zend_Json::encode($clipboard);
        die();
    }
    
    public function addcontentAction()
    {
        $uid       = intval($this->getRequest()->getParam('uid'));
        $parent    = intval($this->getRequest()->getParam('parent')); 
        $sorting   = intval($this->getRequest()->getParam('sorting')); 
        $name      = base64_decode($this->getRequest()->getParam('name'));
        if($uid){ 
            $clipboard = Sicore_Models_Clipboard::addContent($uid, $parent, $sorting, $name); 
        }
        echo Zend_Json::encode($clipboard);
        die();
    }
    
    public function clearAction()
    {
        
        $clipboard = Sicore_Models_Clipboard::clear();
        
        echo Zend_Json::encode(true);
        die();
    }
    
    public function getAction()
    {
        $translate = $translate = Sicore_Models_Registry::getTranslate();  
        $clipboard = Sicore_Models_Clipboard::get();
        
        $clipboard['pageslenstr'] = $clipboard['pageslen'] == 1 
                                  ? '1 '.$translate->translate('GENERAL_PAGE')
                                  :  $clipboard['pageslen'].' '.$translate->translate('GENERAL_PAGES'); 
        $clipboard['contentlenstr'] = $clipboard['contentlen'] == 1 
                                  ? '1 '.$translate->translate('GENERAL_CONTENT')
                                  :  $clipboard['contentlen'].' '.$translate->translate('GENERAL_CONTENTS');
        echo Zend_Json::encode($clipboard);
        die();
    }
    
    public function pasteAction()
    {
        $onlyContent = (bool)$this->getRequest()->getParam('onlycontent');
        $uid         = intval($this->getRequest()->getParam('dest'));
        $mode        = $this->getRequest()->getParam('mode');
        $clipboard   = Sicore_Models_Clipboard::get(); 
        
        $config_be   = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BACKEND);
        
        $mNodes      = new Sicore_Models_Server_Db_Nodes();
        try{
            $node = $mNodes->getByUid($uid);
            if($mode != 'after' && $mode != 'inside') throw new Exception();
        }catch(Exception $e){
            echo Zend_Json::encode(false);
            die();
        }
        
        if($onlyContent && $clipboard['contentlen']){
            $mNodes->copyContent($node, $mode, $clipboard['content']);
        }
           
        if(!$onlyContent && $clipboard['pageslen']){
            $mNodes->copyPages($node, $mode, $clipboard['pages'], intval($config_be->copy->depth));
        }
        
        echo Zend_Json::encode(true);
        die();
    }
         
}