<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: FileController.php 1551 2010-10-07 16:37:27Z ms $
 */
class Sicore_FileController extends Sicore_Controllers_Simploo
{
       
    public function init()
    {

        $this->_helper->contextSwitch()->addActionContext('move', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('remove', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('update', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('move', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('upload', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('check', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('show', 'json');
        $this->_helper->contextSwitch()->addActionContext('edit', 'json');
        $this->_helper->contextSwitch()->addActionContext('insertimageform', 'json');     
        $this->_helper->contextSwitch()->addActionContext('insertlink', 'json'); 
        parent::init();
    }
    
       
    public function removeAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $uid  = intval($this->getRequest()->getparam('uid'));    
        $type = $this->getRequest()->getparam('type'); 
        
        $mFiles = new Sicore_Models_Server_Db_Files();
        $file   = $mFiles->get($uid);
        $this->view->removed = $mFiles->remove($file);
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->removed);
            die();
        }  
    }
        
    public function moveAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidSource  = intval($this->getRequest()->getparam('uidSource'));  
        $uidDest    = intval($this->getRequest()->getparam('uidDest'));
        $typeSource = $this->getRequest()->getparam('typeSource');
        $typeDest   = $this->getRequest()->getparam('typeDest');
        
        $mFiles   = new Sicore_Models_Server_Db_Files();
        $mFolders = new Sicore_Models_Server_Db_Folders(); 
        $source = $mFiles->get($uidSource);
        
        if($typeDest == 'folder'){  
            $folderDest = $mFolders->get($uidDest);
            $mode       = $this->getRequest()->getparam('mode');  
        }elseif($typeDest == 'file'){
            $fileDest   = $mFiles->get($uidDest); 
            $folderDest = $mFolders->get($fileDest->folders_uid->value()); 
            $mode       = 'inside';
        }else{
            echo Zend_Json::encode(false);
            die();
        }
        
        if(!$source || !$folderDest){
            echo Zend_Json::encode(false);
            die(); 
        } 
         
        $this->view->moved = $mFiles->move($source, $folderDest, $mode);
           
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->moved);
            die();
        }
    }
    
    public function uploadAction(){
        if ($this->_request->isPost()){ 
            
            $config_fs = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FILESYSTEM); 
            
            if($config_fs->options->excludeExtension){
                $excludedExtension = explode(',', str_replace(' ', '', $config_fs->options->excludeExtension));
            }else{
                $excludedExtension = array();
            }
            $folder = intval($this->getRequest()->getParam('uid'));
            
            $upload = new Zend_File_Transfer_Adapter_Http();
            $upload->setDestination(Sicore_Models_Helper_FSO::joinPathAbs('data/tmp'));
            $upload->addValidator('ExcludeExtension', false, $excludedExtension);
            $upload->setOptions(array('useByteString' => false));
             
            if($upload->isValid()){
                $info = $upload->getFileInfo();
                $index = isset($info['Filedata']) ? 'Filedata' : 'si_upload_file';                  
                $mImage = new Sicore_Models_Image();  
                if($mImage->isSupported($info[$index]['tmp_name'])){  
                    $file  = new Sicore_Models_FSO_File_Image();
                    $file->type->set($mImage->getMime($info[$index]['tmp_name']));
                    if($config_fs->options->uploadMaxMemoryFactor){
                        $size         = getimagesize($info[$index]['tmp_name']);
                        $memoryUsage  = $size[0] * $size[1] * 5; 
                        $memory       = $config_fs->options->uploadMaxMemoryFactor * ($this->return_bytes(ini_get('memory_limit')) - memory_get_usage());
                        if($memoryUsage > $memory){
                            header('Content-Type: text/plain');
                            
                            $F = $size[0] * $size[1] * $memory/$memoryUsage;
                            
                            $x = floor(sqrt($size[0] / $size[1] * $F));
                            $y = floor(sqrt($size[1] / $size[0] * $F));

                            die("Bild darf nicht größer als ${x}x${y} Pixel sein.");     
   
                        } 
                    }
                }else{
                    $file  = new Sicore_Models_FSO_File();
                    try{
                        $mime = $upload->getMimeType();
                    }catch(Exception  $e){
                        $mime = 'application/octet-stream';
                    }
                    $file->type->set($mime);     
                } 
                $newname = Sicore_Models_Helper_FSO::cleanFilename($upload->getFileName(null, false));
                $file->name->set($newname);               
                $file->folders_uid->set($folder);
                $file->size->set($upload->getFileSize()); 
                
                $mFiles = new Sicore_Models_Server_Db_Files();
                try{
                    if(!($fileExisted = $mFiles->getByName($newname, $folder))){
                        $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files');
                        if(!is_dir($path)){
                            Sicore_Models_Logger::error('Folder not exist: '.$path);
                            header('Content-Type: text/plain'); 
                            die('0'); 
                        }
                        if(!is_writable($path)){
                            Sicore_Models_Logger::error('Folder not writable: '.$path);  
                            header('Content-Type: text/plain'); 
                            die('0');
                        }
                        $uid = $mFiles->create($file);         
                        $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files', $folder, $uid);
                        $upload->addFilter('Rename',
                                array(
                                    'target' => $path.$newname,
                                    'overwrite' => true
                                ));  
                        $upload->receive();
                        $file->onUpdate(); 
                        header('Content-Type: text/plain');  
                        die('1');    
                    }else{
                        $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files', $folder, $fileExisted->uid->value()); 
                        Sicore_Models_Helper_FSO::deleteDirContent($path);  
                        $upload->addFilter('Rename',
                                array(
                                    'target' => $path.$newname,
                                    'overwrite' => true
                                )); 
                        $upload->receive();
                        $fileExisted->onUpdate();
                        header('Content-Type: text/plain');  
                        die('1');
                    } 
                }catch(Exception $e){
                    Sicore_Models_Logger::error('Upload failed: '.$e->__toString());
                    header('Content-Type: text/plain'); 
                    die('0');  
                } 
            }else{       
                Sicore_Models_Logger::error('Upload failed: '.implode("\n", $upload->getErrors()));  
                header('Content-Type: text/plain'); 
                die('0');
            }    
        }else{
            $uid = intval($this->getRequest()->getparam('uid')); 
            $mFolders = new Sicore_Models_Server_Db_Folders();
            $folder   = $mFolders->get($uid);             
            
            $form   = new Sicore_Models_Gui_Form_Upload($folder);
            $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);  
            $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
            $form->setAction($path.'sicore/file/upload/uid/'.$uid);
            
            $data = array();
            $data['title']      = $folder->name->value(); 
            $data['content']    = $form->render(); 
            $data['labelUpload']= $this->view->translate('GENERAL_UPLOAD_START'); 
            $data['labelShow']  = $this->view->translate('GENERAL_SHOW2'); 
            $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
            $data['js']         = $this->view->jQuery()->getJavascriptFiles(); 
            $data['buttonSave'] = strtoupper($this->view->translate('GENERAL_UPLOAD_START'));
            if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
                echo Zend_Json::encode($data);
                die();
            }
        }
       
    }
    
     public function checkAction(){
        $fileArray = array(); 
        if ($this->_request->isPost()){
            
            $postData = $this->getRequest()->getPost();
            
            foreach($postData as $key => $name){
                if ($key == 'folder')  continue;
                $mFiles = new Sicore_Models_Server_Db_Files(); 
                if($mFiles->getByName($name)){
                    $fileArray[$key] = $name;
                }
            }
            
        }
        
        echo Zend_Json::encode($fileArray);
        die();  
    }
    
    public function showAction()
    {
        $uid  = $this->getRequest()->getparam('uid');
        if(substr($uid, 0, 5) == 'pool_'){
            $uid  = substr($uid, 5); 
            $mImages = new Sicore_Models_Server_Http_Images($this->config_base->app->updates);
            $mImages->setCredentials($this->config_base->app->number, $this->config_base->customer->secret);
            
            $pool = $mImages->getByUid($uid);
            if(!$pool['error']){ 
                $this->view->pool      = $mImages->getByUid($uid);
                $data['status']        = (bool)$this->view->pool;
                $data['labelDownload'] = $this->view->translate('GENERAL_DOWNLOAD'); 
                $data['content']       = $this->view->render('media/image.phtml');
            }else{
                Sicore_Models_Logger::error($pool['error']);  
                $data['error'] = true;
            } 
        }else{
            $type = $this->getRequest()->getparam('type'); 
            
            $data = array();
          
            $mFiles = new Sicore_Models_Server_Db_Files();
            $file = $mFiles->get($uid);
             
            $this->view->file = $file;  
             
            $data = array();
            $data['status'] = (bool)$file;
            $data['title']  = $file->name->value();
            
            if($file instanceof Sicore_Models_FSO_File_Image){     
                $data['width']   = $file->getPreview('width');  
                $data['content'] = $this->view->render('media/image.phtml');  
            }else{
                $data['width']   = $file->getPreview('width');
                $data['content'] = $this->view->render('media/file.phtml');
            }
            $data['labelEdit']     = $this->view->translate('GENERAL_EDIT');
            $data['labelDelete']   = ucwords($this->view->translate('GENERAL_DELETE'));
            $data['labelDownload'] = $this->view->translate('GENERAL_DOWNLOAD');
        }
        echo Zend_Json::encode($data);
        die();      
    }
    
    public function downloadlicenceAction()
    {
        $uid = $this->getRequest()->getparam('uid');
        $uid = substr($uid, 5); 
        $mImages = new Sicore_Models_Server_Http_Images($this->config_base->app->updates);
        $mImages->setCredentials($this->config_base->app->number, $this->config_base->customer->secret);
        
        $image = $mImages->getByUid($uid);  
        
        if(!$image['error']){ 
            $data['labelDownload'] = $this->view->translate('GENERAL_DOWNLOAD_ACCEPT');
            $data['labelCancel']   = $this->view->translate('GENERAL_CANCEL');    
            $data['content']       = $mImages->getLicence($uid); 
            $data['title']         = $image['filename']; 
        }else{
            Sicore_Models_Logger::error($image['error']);  
            $data['error'] = true;
        }
        
        echo Zend_Json::encode($data);
        die();   
        
    }
    
    public function downloadpoolAction()
    {
        $uid = $this->getRequest()->getparam('uid');
        $uid  = substr($uid, 5); 
        try{
            //Init 
            $mImagePool = new Sicore_Models_Server_Http_Images($this->config_base->app->updates);
            $mImage     = new Sicore_Models_Image(); 
            $mFolders   = new Sicore_Models_Server_Db_Folders();
            $mFiles     = new Sicore_Models_Server_Db_Files(); 
            //Get Image
            $mImagePool->setCredentials($this->config_base->app->number, $this->config_base->customer->secret);
            $image    = $mImagePool->getByUid($uid);
            if(!$image || $image['error']) throw new Exception('Image Download, unkown ID');
            $tempFile = $mImagePool->download($uid);
            if(!$tempFile) throw new Exception('Image Download failed');  
            //Save and generate Image
            $rootFolder = $mFolders->getRootFolder();
            $file       = new Sicore_Models_FSO_File_Image();
            $file->type->set($mImage->getMime($tempFile));
            $file->name->set($image['filename']);               
            $file->folders_uid->set($rootFolder->uid->value());
            $file->size->set(filesize($tempFile)); 
            if(!($fileExisted = $mFiles->getByName($image['filename'], $rootFolder->uid->value()))){ 
                $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files'); 
                $uid  = $mFiles->create($file); 
                $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files', $rootFolder->uid->value(), $uid);
                rename($tempFile, $path.$image['filename']); 
                $file->onUpdate();   
            }else{
                $path = Sicore_Models_Helper_FSO::joinPathAbs('data/files', $rootFolder->uid->value(), $fileExisted->uid->value()); 
                Sicore_Models_Helper_FSO::deleteDirContent($path); 
                rename($tempFile, $path.$image['filename']);
                $fileExisted->onUpdate();     
            }
            @unlink($tempFile);
        }catch(Exception $e){
            @unlink($tempFile);
            Sicore_Models_Logger::exception($e);
            $data['status']    = false;
            $data['msg_title'] = $this->view->translate('LL_POOL_DOWNLOAD_ERROR_TITLE');
            $data['msg_text']  = $this->view->translate('LL_POOL_DOWNLOAD_ERROR_TEXT');
            echo Zend_Json::encode($data);
            die();
        }
            
        $data['status']    = true;
        $data['msg_title'] = $this->view->translate('LL_POOL_DOWNLOAD_MESSAGE_TITLE');
        $data['msg_text']  = $this->view->translate('LL_POOL_DOWNLOAD_MESSAGE_TEXT');
        echo Zend_Json::encode($data);
        die();;
    }
    
    public function editAction()
    {
        $uid    = intval($this->getRequest()->getparam('uid')); 
        $mFiles = new Sicore_Models_Server_Db_Files();
        $file   = $mFiles->get($uid);
        
        $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);                   
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $form   = new Sicore_Models_Gui_Form_Backend($file, $this->user);
        $form->setAction($path.'sicore/file/save');
        
        $data = array();
        $data['labelSave'] = $this->view->translate('GENERAL_SAVE');
        $data['labelShow']  = $this->view->translate('GENERAL_SHOW2'); 
        $data['title']      = $file->name->value(); 
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';
        $data['buttonSave'] = strtoupper($this->view->translate('GENERAL_SAVE'));
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function downloadAction()
    {
        $uid  = intval($this->getRequest()->getparam('uid'));
        $mode = $this->getRequest()->getparam('mode'); 
        $mFiles = new Sicore_Models_Server_Db_Files();
        if(!($file  = $mFiles->get($uid))){
            throw new Sifront_Models_Exception_Pagenotfound();
        }
                
        header('HTTP/1.1 200 OK');
        header('Content-type: '.Sicore_Models_Helper_FSO::getMime($file->name->value()));
        header('Content-Length: '.$file->getSize());
        header('Content-Disposition: attachment; filename="'.$file->name->value().'"');
        
        if($file instanceof Sicore_Models_FSO_File_Image){
            Sicore_Models_Helper_FSO::readfile($file->getRealPath($mode));
        }else{
            Sicore_Models_Helper_FSO::readfile($file->getRealPath());
        }
        die();
    }
    
    public function saveAction(){

        $translate = Sicore_Models_Registry::getTranslate();
        
        if($this->getRequest()->isPost()){
            $formData = $this->getRequest()->getPost();
            $uid = intval($this->getRequest()->getparam('uid')); 
             
            $uid    = intval($this->getRequest()->getparam('uid')); 
            $mFiles = new Sicore_Models_Server_Db_Files();
            $file   = $mFiles->get($uid);
                           
            $form   = new Sicore_Models_Gui_Form_Backend($file, $this->user);
            
            $data = array();
            
            if (!$form->isValid($formData)) {
                $errors = array();
                if(($subForms = $form->getSubForms())){
                    $counter = 0;   
                    foreach($subForms as $subForm){
                        $elements =  $subForm->getElements();
                        foreach($elements as $element){
                            if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                                $errors[] = $error;
                                $fields[] = $element->getName();
                                $subformIndexs[]    = ++$counter;      
                            }
                        }
                    }
                }else{
                    $elements =  $subForms->getElements();
                    foreach($elements as $element){
                        if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                                $errors[] = $error; 
                                $fields[] = $element->getName();    
                            }    
                    }
                    $subForms = array(); 
                }
                $data['saved']  = false;
                $data['errors'] = $errors;
                $data['fields'] = $fields;
                $data['subforms']  = $subformIndexs;  
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                $className =  $formData['class'];
                $file = new $className($formData);
                if($mFiles->update($file)){
                    $data['saved']  = true;
                    $data['uid']    = $file->uid->value();
                    $data['title']  = $file->name->value();  
                    $data['parent']  = $file->uid_parent->value();  
                    $data['type']  = 'file';
                    $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
                }else{
                    $data['saved']  = false;
                    $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
                }  
            }
            
            echo Zend_Json::encode($data);
            die();
        }
    }
    
     public function insertlinkAction()
    {
       
        $uid    = intval($this->getRequest()->getparam('uid')); 
        $mFiles = new Sicore_Models_Server_Db_Files();
        $file   = $mFiles->get($uid);
        
        $data = array(); 
        
        if ($this->_request->isPost()){                        
            if(($href = (string)$this->view->linkfile($uid, $this->config_base->gfx->superbox))){
                $data['type']   = 'file';
                $data['href']   = $href; 
                $data['uid']    = $uid;  
                $target         = str_replace('"', '', strip_tags($this->getRequest()->getparam('target'))); 
                $title          = str_replace('"', '', strip_tags($this->getRequest()->getparam('title'))); 
                $data['target'] = $target; 
                $data['title']  = $title; 
                $data['saved']  = true;
            }else{
                $data['saved']     = false;
                $data['errors'][]  = $translate->_('E_GENERAL_LINKTARGET');
                $data['fields'][]  = 'uid';
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }   
        }else{
            $path   = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
            $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
            if($file instanceof Sicore_Models_FSO_File_Image){
                $type = Sicore_Models_Gui_Form_Link::IMAGE;
            }else{
                $type = Sicore_Models_Gui_Form_Link::FILE; 
            }
            
            $form   = new Sicore_Models_Gui_Form_Link($type,
                                                      $file ? $file->uid->value() : null,
                                                      $file ? $file->name->value() : null,
                                                      $file ? $file->title->value() : null,
                                                      null
                                                      ); 
            
            
            $form->setAction($path.'sicore/file/insertlink');
            $data['labelInsert']  = $this->view->translate('GENERAL_INSERT');
            $data['labelDelete']  = $this->view->translate('GENERAL_DELETELINK'); 
            $data['title']        = $file ? $file->name->value() : $this->view->translate('GENERAL_INSERT'); 
            $data['content']      = $form->render(); 
            $data['scripts'][]    = "$('#tabContainer').tabs({
                                                                select: function(event, ui) { 
                                                                    if(ui.index == 1){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertexternallink');
                                                                    }else{
                                                                        $('#si_blackbox1').css('z-index', 500);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/file/insertlink'); 
                                                                    }
                                                                 }
                                                               });
                                    ";
                                     
        }
            
        echo Zend_Json::encode($data);
        die();
    }
        
    function insertimageAction()
    {
        $translate = Sicore_Models_Registry::getTranslate(); 
        $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $uid = intval($this->getRequest()->getparam('uid')); 
        
        $data = array(); 
        
        if ($this->_request->isPost()){
            $mFiles = new Sicore_Models_Server_Db_Files();
            $file   = $mFiles->get($uid);
            
            $superbox  = (bool)$this->getRequest()->getparam('usesuperbox');
            $oldimagesize = str_replace('"', '', strip_tags($this->getRequest()->getparam('oldimagesize')));
            $imagesize    = str_replace('"', '', strip_tags($this->getRequest()->getparam('imagesize'))); 
            $alt          = str_replace('"', '', strip_tags($this->getRequest()->getparam('alt')));
            $title        = str_replace('"', '', strip_tags($this->getRequest()->getparam('title'))); 
            $style        = str_replace('"', '', strip_tags($this->getRequest()->getparam('style')));
            $height       = intval($this->getRequest()->getparam('height')); 
            $width        = intval($this->getRequest()->getparam('width'));
            
            if($oldimagesize == $imagesize){
                $height = $height ? ' height = "'.$height .'"' : '';
                $width  = $width  ? ' width = "'.$width .'"'   : '';   
            }else{
                $height = '';
                $width  = ''; 
                $style  = preg_replace('/width:\s*\d*px;/i', '', $style);
                $style  = preg_replace('/height:\s*\d*px;/i', '', $style);
            }
            
            if($superbox && ($superBoxImage = $file->get($this->config_base->gfx->superbox))){
                $data['image'] = '<a rel="superbox[gallery][page]" target="superbox[gallery][page]" type="file" uid="'.$uid.'" href="'.$this->view->linkfile($uid, $this->config_base->gfx->superbox).'"><img class="'.$imagesize.'" imagesize="'.$imagesize.'" style="'.$style.'" uid="'.$uid.'" alt="'.$alt.'" title="'.$title.'" src="'.$this->view->linkfile($uid, $imagesize).'" '.$height.$width.' /></a>';   
                $data['uid']     = $uid;
            }else{
                $data['image'] = '<img class="'.$imagesize.'" imagesize="'.$imagesize.'" style="'.$style.'" uid="'.$uid.'" alt="'.$alt.'" title="'.$title.'" src="'.$this->view->linkfile($uid, $imagesize).'" '.$height.$width.' />';
                $data['uid']     = $uid; 
            }
            
            $data['saved'] = true;      
        }else{
            
            $mFiles = new Sicore_Models_Server_Db_Files();
            $file   = $mFiles->get($uid);
          
            if(!$file || !($file instanceof Sicore_Models_FSO_File_Image)){
                return;
            }else{ 
            
                $form   = new Sicore_Models_Gui_Form_Image($file->uid->value(),
                                                           $file->getPreview(), 
                                                           $file->name->value(),
                                                           $file->name->value()
                                                           );  
                $form->setAction($path.'sicore/file/insertimage');
                
                $data['labelInsert']  = $translate->_('GENERAL_INSERT');
                $data['labelDelete']  = $translate->_('GENERAL_DELETEIMAGE'); 
                $data['content']      = $form->render();  
                $data['scripts']      = $this->view->jQuery()->getOnLoadActions();
            }               
        }
        
        echo Zend_Json::encode($data);
        die();
    }
    
    
    private function return_bytes($val) {
        $val = trim($val);
        $last = strtolower($val[strlen($val)-1]);
        switch($last) {
            case 'g':
                $val *= 1024;
            case 'm':
                $val *= 1024;
            case 'k':
                $val *= 1024;
        }

        return $val;
    } 
}