<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: FolderController.php 1551 2010-10-07 16:37:27Z ms $
 */
class Sicore_FolderController extends Sicore_Controllers_Simploo
{
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('move', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('remove', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('update', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('move', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('copy', 'json');  
        $this->_helper->contextSwitch()->addActionContext('create', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('show', 'json');   
        $this->_helper->contextSwitch()->addActionContext('edit', 'json'); 
        parent::init();
    }
    
    public function editAction()
    {
        $uid      = intval($this->getRequest()->getparam('uid')); 
        $mFolders = new Sicore_Models_Server_Db_Folders();
        $folder   = $mFolders->get($uid);
        
        $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);                   
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $form   = new Sicore_Models_Gui_Form_Backend($folder, $this->user);
        $form->setAction($path.'sicore/folder/save');
        
        $data = array();
        $data['labelSave']  = $this->view->translate('GENERAL_SAVE');
        $data['labelShow']  = $this->view->translate('GENERAL_SHOW2'); 
        $data['title']      = $folder->name->value(); 
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';
        $data['buttonSave'] = strtoupper($this->view->translate('GENERAL_SAVE'));
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function saveAction(){

        $translate = Sicore_Models_Registry::getTranslate();
        
        if($this->getRequest()->isPost()){
            $formData = $this->getRequest()->getPost();
            $uid = intval($this->getRequest()->getparam('uid')); 
             
            $uid      = intval($this->getRequest()->getparam('uid')); 
            $mFolders = new Sicore_Models_Server_Db_Folders();
            $folder   = $mFolders->get($uid);
                           
            $form   = new Sicore_Models_Gui_Form_Backend($folder, $this->user);
            
            $data = array();
            
            if (!$form->isValid($formData)) {
                $errors = array();
                if(($subForms = $form->getSubForms())){
                    $counter = 0;       
                    foreach($subForms as $subForm){
                        $elements =  $subForm->getElements();
                        foreach($elements as $element){
                            if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                                $errors[] = $error;
                                $fields[] = $element->getName(); 
                                $subformIndexs[]    = ++$counter;    
                            }
                        }
                    }
                }else{
                    $elements =  $subForms->getElements();
                    foreach($elements as $element){
                        if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                                $errors[] = $error; 
                                $fields[] = $element->getName();    
                            }    
                    }
                    $subForms = array(); 
                }
                $data['saved']  = false;
                $data['errors'] = $errors;
                $data['fields'] = $fields;
                $data['subforms']  = $subformIndexs;  
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                $formData = array();
                if(($subForms = $form->getSubForms())){ 
                    foreach($subForms as $subForm){  
                        $formData = array_merge($formData, $subForm->getValues());
                    }
                }else{
                    $formData = $form->getValues(); 
                }
                  
                $newFolder = new Sicore_Models_FSO_Folder($formData);
                
                $mFolders->update($newFolder);
                
                $data['saved'] = true;
                $data['uid']   = $newFolder->uid->value();
                $data['type']  = 'folder';
                $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
            }
            
            echo Zend_Json::encode($data);
            die();
        }
    }
       
    public function createAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidDest   = intval($this->getRequest()->getparam('uidDest'));
          
        $name      = base64_decode(urldecode($this->getRequest()->getparam('name')));
        $mode      = $this->getRequest()->getparam('mode') == 'after' ? 'after' :'inside' ; 
        
        $mFolder    = new Sicore_Models_Server_Db_Folders();
        $folderDest = $mFolder->get($uidDest);
        
        $this->view->newid = $mFolder->create($folderDest, $name, $mode);
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->newid);
            die();
        }

    }
    
    public function removeAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $uid  = intval($this->getRequest()->getparam('uid'));    
        
        if($uid > 1){
            $mFolders = new Sicore_Models_Server_Db_Folders();
            $folder   = $mFolders->get($uid);
            $this->view->removed = $mFolders->remove($folder);
        }    
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->removed);
            die();
        }  
    }
    
    
    public function moveAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidSource  = intval($this->getRequest()->getparam('uidSource'));  
        $uidDest    = intval($this->getRequest()->getparam('uidDest'));
        $typeSource = $this->getRequest()->getparam('typeSource');
        $typeDest   = $this->getRequest()->getparam('typeDest');
        
        $mFolders     = new Sicore_Models_Server_Db_Folders();
        $mFiles       = new Sicore_Models_Server_Db_Files(); 
        
        $source = $mFolders->get($uidSource);         
        
        if($typeDest == 'folder'){  
            $folderDest   = $mFolders->get($uidDest);
            $mode         = $this->getRequest()->getparam('mode'); 
        }elseif($typeDest == 'file'){
            $fileDest   = $mFiles->get($uidDest); 
            $folderDest = $mFolders->get($fileDest->folders_uid->value());
            $mode       = 'inside'; 
        }else{
            echo Zend_Json::encode(false);
            die();
        }
        
        $this->view->moved = $mFolders->move($source, $folderDest, $mode);

        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->moved);
            die();
        }
    }
    
    public function updateAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        $uid       = intval($this->getRequest()->getparam('uid'));    

        $name      = base64_decode(urldecode($this->getRequest()->getparam('name')));    
        if(!empty($name)){
            $mFolders = new Sicore_Models_Server_Db_Folders();
            $folder   = $mFolders->get($uid);
            $folder->name->set($name);
            
            $mFolders->update($folder);
        }
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode(true);
            die();
        }  
    }
        
    public function showAction()
    {
        $uid  = $this->getRequest()->getparam('uid');
        $data = array();
        if(substr($uid, 0, 5) == 'pool_'){
            $parent  = substr($uid, 5); 
            $mImages = new Sicore_Models_Server_Http_Images($this->config_base->app->updates);
            $mImages->setCredentials($this->config_base->app->number, $this->config_base->customer->secret);

            $pool        = $mImages->getByFolder($parent);
            $poolFolders = $mImages->getCategories($parent);
            $poolFolder  = $mImages->getCategory($parent);
            
            $view->files       = array();
            $view->folders     = array();
            $view->pool        = $pool['error']        ? array() : $pool; 
            $view->poolFolders = $poolFolders['error'] ? array() : $poolFolders; 
            $view->poolFolder  = $poolFolder; 
            $view->poolUp      = $parent;
            $view->size        = $this->config_base->gfx->sizes->thumb;
            $this->view->data  = $view;
            
            $data['title']       = $view->poolFolder['title']; 
            $data['content']     = $this->view->render('media/folder.phtml');
        }else{ 
            $type = $this->getRequest()->getparam('type'); 
            
            $view  = new stdClass();
            
            $mFolders = new Sicore_Models_Server_Db_Folders(); 
            $folder   = $mFolders->get($uid);
            if(!($folder instanceof Sicore_Models_FSO_Folder)) throw new Exception ('Folder uid='.$uid.' not found.');
            $data['title'] = $folder->name->value(); 
                        
            $mFiles = new Sicore_Models_Server_Db_Files();
            $view->folder      = $folder;
            $view->files       = $mFiles->getByFolder($uid);
            $view->folders     = $mFolders->getByParentUid($uid);  
            $view->pool        = array();
            $view->poolFolders = array();
            $view->poolFolder  = null;  
            $view->size        = $this->config_base->gfx->sizes->thumb;
             
            $this->view->data    = $view;
            $data['content']     = $this->view->render('media/folder.phtml');
            $data['labelUpload'] = $this->view->translate('GENERAL_UPLOAD');  
            $data['labelEdit']   = $this->view->translate('GENERAL_EDIT'); 
            if($folder->level->value()){
                $data['labelDelete'] = ucwords($this->view->translate('GENERAL_DELETE'));
            }
        }
        echo Zend_Json::encode($data);
        die();      
    }
     
}