<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: MenuController.php 1547 2010-09-28 13:37:58Z ms $
 */
class Sicore_MenuController extends Sicore_Controllers_Simploo  
{
    const ID_PREFIX   = 'si_tree_settings_';  
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('show',     'json');
        $this->_helper->contextSwitch()->addActionContext('show2',    'json'); 
        $this->_helper->contextSwitch()->addActionContext('panel',    'json');
        $this->_helper->contextSwitch()->addActionContext('button',   'json');
        $this->_helper->contextSwitch()->addActionContext('choosertree',   'json');  
        $this->_helper->contextSwitch()->addActionContext('choosercontent',   'json');  
        parent::init();
    }
    
    public function panelAction(){
        
        $pathBackend  = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path, '/templates/backend/', $this->config_backend->layout);
        $path         = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
        
        $pageUid      = intval($this->getRequest()->getParam('page'));
        $lang         = $this->getRequest()->getParam('lang');
        
        $this->view->headScript()->appendFile($path.'lib/JSTree/_lib.js');
        $this->view->headScript()->appendFile($path.'lib/JSTree/tree_component.js'); 
        $this->view->headScript()->appendFile($path.'lib/JSTree/css.js');
        $this->view->headScript()->appendFile($path.'lib/JSTree/metadata.js'); 
        $this->view->headScript()->appendFile($path.'lib/JSTree/cookie.js');  
        $this->view->headScript()->appendFile($path.'lib/JSTree/jquery.form.js');
        $this->view->headScript()->appendFile($path.'lib/Simploo/editor/allin.js'); 
         
        $this->view->headScript()->appendFile($path.'lib/JQuery/uploader/jquery.uploadify.v2.0.3.min.js'); 
        $this->view->headScript()->appendFile($path.'lib/JQuery/uploader/swfobject.js'); 
        
        //$this->view->headScript()->appendFile($path.'application/Sicore/Javascript/simploo/gui.js');
        //$this->view->headScript()->appendFile($path.'application/Sicore/Javascript/simploo/gui/content.js');
        
        $this->view->headLink()->appendStylesheet($path.'lib/JQuery/uploader/uploadify.css'); 
        $this->view->headLink()->appendStylesheet($pathBackend.'_themes/jstree/tree_component.css'); 
        $this->view->headLink()->appendStylesheet($pathBackend.'_themes/jquery/jquery-ui-1.7.2.simploo.css'); 
        $this->view->headLink()->appendStylesheet($pathBackend.'_css/panel.css');   
        $this->view->headLink()->appendStylesheet($pathBackend.'_css/edit.css'); 
        $this->view->headLink()->appendStylesheet($pathBackend.'_css/editor.css');
        
        $mNode    = new Sicore_Models_Server_Db_Nodes();
        //$mVersion = new Sicore_Models_Server_Db_Version();
        
        $page = $mNode->get($pageUid, $lang, true);
                
        //$this->view->versions        = $mVersion->getByPage($pageUid);
       
        $this->view->canPublish      = $page->canpublish->check($this->user) && ($page->getSubnodesVersion() || $page->version->value());
    }
    
    public function choosercontentAction()
    {
        $name = $this->getRequest()->getParam('uid');
        $path = Sicore_Models_Helper_FSO::joinPathAbs('application/Sicore/Models/Node/Content'); 
        
        $status = true;
        $element = new stdClass();
        $element->uid        = $name; 
        $element->title      = $this->view->translate(strtoupper($name));   
        $element->object     = $name; 
        
        $this->view->cobject = $element; 

        $content = $this->view->render('chooser/menu.phtml'); 
        
        $data    = array('status'  => $status,
                         'content' => $content
                        );
                        
        die(Zend_Json::encode($data));
    }
    
    public function choosertreeAction()
    {
        $config_backend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BACKEND);
        $menus          = $config_backend->modules->toArray();    
        
        $data      = array();
        $icon      = null;
        foreach($menus as $menu){
            try{
                if(empty($menu)) continue;        
                $mMenu = new $menu();
            }catch(Exception $e){
                Sicore_Models_Logger::exception($e); 
                continue;
            }
            if(!($mMenu instanceof Sicore_Models_Gui_Menu_Interface)){
                continue;
            }
            
            $keys   = explode('_', $setting->uid);
            $icon   = empty($setting->action) ? 'icon_container.gif' : 'icon_settings.gif'; 
            
            $data[] = array('attributes' => array('id'              => self::ID_PREFIX.$setting->uid,
                                                  'uid'             => $menu, 
                                                  'title'           => $this->view->translate(strtoupper($menu)),
                                                  'metadata'        => array("draggable" => false), 
                                                  'object'          => $menu,  
                                                ),         
                              'state'      => 'opened',
                              'data'       => array('title' => $this->view->translate(strtoupper($menu)), 
                                                    'icon'  => $icon
                                                    ) 
                              );  
        }
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        } 
    }
    
    public function indexAction()
    {
        $this->dispatch('buttonAction');
    }
    
    public function showAction()
    {
        $mUser = Sicore_Models_Registry::getUser();
        
        $mMenu = new Sicore_Models_Gui_Menu();
        $mMenu->appendFilesToView();
        $mMenu->append('name', $mUser->getName());
        $mMenu->render();
    }
    
    public function show2Action()
    {
        $mMenu2 = new Sicore_Models_Gui('gui/menu2', 'menu2.js');
        $mMenu2->appendFilesToView();
        $mMenu2->render(); 
    }
    
}