<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: PagesController.php 1545 2010-09-23 08:41:52Z ms $
 */
class Sicore_PagesController extends Sicore_Controllers_Simploo
{
    
    const ID_PREFIX   = 'si_tree_p_';  
    const ID_PREFIX_2 = 'si_treedrop_p_';
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('tree',       'json');
        $this->_helper->contextSwitch()->addActionContext('load',       'json'); 
        $this->_helper->contextSwitch()->addActionContext('choosertree','json');
        $this->_helper->contextSwitch()->addActionContext('choosercontent','json');
        $this->_helper->contextSwitch()->addActionContext('rename',     'json');
        $this->_helper->contextSwitch()->addActionContext('move',       'json');
        $this->_helper->contextSwitch()->addActionContext('copy',       'json'); 
        $this->_helper->contextSwitch()->addActionContext('remove',     'json');
        $this->_helper->contextSwitch()->addActionContext('undo',       'json'); 
        $this->_helper->contextSwitch()->addActionContext('publish',    'json');
        $this->_helper->contextSwitch()->addActionContext('create',     'json'); 
        $this->_helper->contextSwitch()->addActionContext('edit',       'json'); 
        $this->_helper->contextSwitch()->addActionContext('save',       'json');
        $this->_helper->contextSwitch()->addActionContext('versions',   'json'); 
        $this->_helper->contextSwitch()->addActionContext('droppage',   'json'); 
        $this->_helper->contextSwitch()->addActionContext('insertlink', 'json');
        $this->_helper->contextSwitch()->addActionContext('saveProperty', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('insertexternallink', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('insertemaillink', 'json');
        $this->_helper->contextSwitch()->addActionContext('getunpublished', 'json'); 
         
        parent::init();
    }
    
    public function showAction()
    {
        //sdsd
    }
    
    public function treeAction()
    {
        $mPages = new Sicore_Models_Gui_Menu_Pages();
        $mPages->appendFilesToView();
        $mPages->render(); 
    }
    
    public function loadAction()
    {
        $parentUid = intval($this->getRequest()->getparam('uid'));  
        
        $isDraft = (bool)$this->getRequest()->getParam('draft',  false); 
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $nodes = $mNodes->doCheckParents(true)
                        ->setDraft($isDraft)
                        ->doCheckIsDeleted(false)
                        ->doCheckIsActive(false)
                        ->doCheckDate(false)
                        ->getByParentUid($parentUid, array('Sicore_Models_Node_Page'));
                  
        $data = array();
        
        $editable  = in_array('Sicore_Models_Gui_Menu_Pages', $this->user->gui_menu_enabled->toArray()) || $this->user->isadmin->value(); 
        
        
        foreach($nodes as $node){
            if($node->external->value()){
                if($node->version_status->value() == 'DELETED'){
                    $icon = 'icon_external_deleted.gif';
                }elseif(!$node->isActive->value()){
                    $icon = 'icon_external_inactive.gif';
                }elseif($node->isHidden->value()){
                    $icon = 'icon_external_hidden.gif';
                }elseif($node->checkDate(new Zend_Date()) == 0){
                    $icon = 'icon_external_inactive_timer.gif';
                }elseif($node->checkDate(new Zend_Date()) == 1){
                    $icon = 'icon_external_active_timer.gif';
                }else{
                    $icon = 'icon_external_active.gif'; 
                } 
            }elseif($node->redirect->value() || $node->autoredirect->value()){
                if($node->version_status->value() == 'DELETED'){
                    $icon = 'icon_redirect_deleted.gif';
                }elseif(!$node->isActive->value()){
                    $icon = 'icon_redirect_inactive.gif';
                }elseif($node->isHidden->value()){
                    $icon = 'icon_redirect_hidden.gif';
                }elseif($node->checkDate(new Zend_Date()) == 0){
                    $icon = 'icon_redirect_inactive_timer.gif';
                }elseif($node->checkDate(new Zend_Date()) == 1){
                    $icon = 'icon_redirect_active_timer.gif';
                }else{
                    $icon = 'icon_redirect_active.gif'; 
                }
            }elseif($node->access->value()){
                if($node->version_status->value() == 'DELETED'){
                    $icon = 'icon_securepage_deleted.gif';
                }elseif(!$node->isActive->value()){
                    $icon = 'icon_securepage_inactive.gif';
                }elseif($node->isHidden->value()){
                    $icon = 'icon_securepage_hidden.gif';
                }elseif($node->checkDate(new Zend_Date()) == 0){
                    $icon = 'icon_securepage_inactive_timer.gif';
                }elseif($node->checkDate(new Zend_Date()) == 1){
                    $icon = 'icon_securepage_active_timer.gif';
                }else{
                    $icon = 'icon_securepage_active.gif'; 
                }
            }else{
                if($node->version_status->value() == 'DELETED'){
                    $icon = 'icon_page_deleted.gif';
                }elseif(!$node->isActive->value()){
                    $icon = 'icon_page_inactive.gif';
                }elseif($node->isHidden->value()){
                    $icon = 'icon_page_hidden.gif';
                }elseif($node->checkDate(new Zend_Date()) == 0){
                    $icon = 'icon_page_inactive_timer.gif';
                }elseif($node->checkDate(new Zend_Date()) == 1){
                    $icon = 'icon_page_active_timer.gif';
                }else{
                    $icon = 'icon_page_active.gif'; 
                }  
            } 
            
            $isChanged = ($node->getSubnodesVersion() || $node->version->value() > 0);
            
            if(($parent = $node->getParent())){
                $parentCanAddSubpages     = $parent->canaddsubpages->check($this->user);
                $parentCanEditSubpages    = $parent->caneditsubpages->check($this->user);
                $parentCanEditSubcontent  = $parent->caneditsubcontent->check($this->user);
                $parentCanPublishSubpages = $parent->canpublishsubpages->check($this->user);
                $parentCanUndoSubpages    = $parent->canundosubpages->check($this->user); 
                $parentCanDeleteSubpages  = $parent->candeletesubpages->check($this->user); 
            }else{
                $parentCanAddSubpages     = false;  
                $parentCanEditSubpages    = false;  
                $parentCanEditSubcontent  = false;  
                $parentCanPublishSubpages = false;  
                $parentCanUndoSubpages    = false;  
                $parentCanDeleteSubpages  = false; 
            }

            $isDeleted = ($node->version_status->value() == 'DELETED');
            $isAdded   = ($node->version_status->value() == 'ADDED');
             
            $data[] = array('attributes' => array('id'              =>  self::ID_PREFIX.$node->uid->value(),
                                                  'uid'             => $node->uid->value(),
                                                  'level'           => $node->getTree()->level->value(),
                                                  'title'           => '['.$node->uid->value().'] '.$node->title->value(),
                                                  'isActive'        => intval($node->isActive->value()),
                                                  'isDeleted'       => intval($isDeleted),
                                                  'isAdded'         => intval($isAdded),
                                                  'isHidden'        => intval($node->isHidden->value()),
                                                  'isChanged'       => intval($isChanged), 
                                                  'isChangedSub'    => intval($node->getSubnodesVersion()),
                                                  'canShow'         => intval(!$isDeleted),
                                                  'canDelete'       => intval($editable && ($node->candelete->check($this->user) || $parentCanDeleteSubpages) && $node->getTree()->level->value() && !$isDeleted  && intval($isDraft)), 
                                                  'canAddSubpages'  => intval($editable && $node->canaddsubpages->check($this->user) && !$isDeleted && intval($isDraft)), 
                                                  'canAddPage'      => intval($editable && !$isDeleted  && $parentCanAddSubpages  && intval($isDraft)), 
                                                  'canEdit'         => intval($editable && ($node->caneditpage->check($this->user) || $parentCanEditSubpages) && !$isDeleted && intval($isDraft)),
                                                  'canPublish'      => intval($editable && ($node->canpublish->check($this->user) || $parentCanPublishSubpages) && intval($isDraft) && ($isChanged || $isDeleted || $isAdded)),                                                   
                                                  'canUndo'         => intval($editable && ($node->canundo->check($this->user) || $parentCanUndoSubpages) && intval($isDraft) && ($isChanged || $isDeleted || $isAdded)),                                                   
                                                  'canMove'         => intval($editable && $isDraft),
                                                  'canCopy'         => intval($node->getTree()->level->value() > 0),
                                                  'canPasteContent' => intval($editable && ($node->caneditpage->check($this->user) || $parentCanEditSubpages) && !$isDeleted && intval($isDraft)),
                                                  'canPasteSubpage' => intval($editable && $node->canaddsubpages->check($this->user) && !$isDeleted && intval($isDraft)), 
                                                  'canPastePage'    => intval($editable && !$isDeleted  && $parentCanAddSubpages  && intval($isDraft)), 
                                                  'uidRedirect'     => $node->redirect->value(), 
                                                  'accessList'      => $node->access->value(),
                                                  'startdate'       => $node->startdate->value(),
                                                  'enddate'         => $node->enddate->value(),
                                                  'external'        => $node->external->value(),
                                                  'isDraft'         => intval($isDraft),
                                                  'metadata'        => array("draggable" => true),
                                                  'object'          => get_class($node)
                                                ),         
                          'state'      => 'closed',
                          'data'       => array('title' => $node->title->value(), 
                                                'icon'  => $icon
                                                ) 
                          );   
        }                  
        
        $this->view->data = $data; 
      
    }
    
    public function choosertreeAction()
    {
        $parentUid = intval($this->getRequest()->getparam('uid'));  
                
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $nodes = $mNodes->doCheckParents(true)
                        ->setDraft(true)
                        ->doCheckIsDeleted(false)
                        ->doCheckIsActive(false)
                        ->doCheckDate(false)
                        ->getByParentUid($parentUid, array('Sicore_Models_Node_Page'));
                  
        $data = array();
        
        foreach($nodes as $node){
            if($node->external->value()){
                $icon = 'icon_external_active.gif'; 
            }elseif($node->redirect->value() || $node->autoredirect->value()){
                $icon = 'icon_redirect_active.gif'; 
            }elseif($node->access->value()){
                $icon = 'icon_securepage_active.gif'; 
            }else{
                if($node->version_status->value() == 'DELETED'){
                    $icon = 'icon_page_deleted.gif';
                }elseif(!$node->isActive->value()){
                    $icon = 'icon_page_inactive.gif';
                }elseif($node->isHidden->value()){
                    $icon = 'icon_page_hidden.gif';
                }elseif($node->checkDate(new Zend_Date()) == 0){
                    $icon = 'icon_page_inactive_timer.gif';
                }elseif($node->checkDate(new Zend_Date()) == 1){
                    $icon = 'icon_page_active_timer.gif';
                }else{
                    $icon = 'icon_page_active.gif'; 
                }  
            } 
            
            $data[] = array('attributes' => array('id'              =>  self::ID_PREFIX_2.$node->uid->value(),
                                                  'uid'             => $node->uid->value(),
                                                  'level'           => $node->getTree()->level->value(),
                                                  'title'           => '['.$node->uid->value().'] '.$node->title->value(),
                                                  'isActive'        => intval($node->isActive->value()),
                                                  'isDeleted'       => intval($isDeleted),
                                                  'isAdded'         => intval($isAdded),
                                                  'isHidden'        => intval($node->isHidden->value()),
                                                  'uidRedirect'     => $node->redirect->value(), 
                                                  'accessList'      => $node->access->value(),
                                                  'startdate'       => $node->startdate->value(),
                                                  'enddate'         => $node->enddate->value(),
                                                  'external'        => $node->external->value(),
                                                  'metadata'        => array("draggable" => false),
                                                  'object'          => get_class($node)
                                                ),         
                          'state'      => 'closed',
                          'data'       => array('title' => $node->title->value(), 
                                                'icon'  => $icon
                                                ) 
                          );   
        }                  
        
        $this->view->data = $data; 
    }
    
    public function choosercontentAction()
    {
        $uid = intval($this->getRequest()->getParam('uid'));
        
        $data    = array();
        $mNodes  = new Sicore_Models_Server_Db_Nodes();
        
        $this->view->content = $mNodes->getByParentUid($uid, array('Sicore_Models_Node_Content'), array(), true, 0, false, true);
        $this->view->page    = $mNodes->getByUid($uid); 

        
        $content = $this->view->render('chooser/pages.phtml'); 
        
        $data    = array('status'  => true,
                         'content' => $content
                        );
                        
        die(Zend_Json::encode($data));
    }
    
    public function renameAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        $uid       = intval($this->getRequest()->getparam('uid'));  
        $name      = base64_decode(urldecode($this->getRequest()->getparam('name')));    
        if(!($lang = $this->getRequest()->getParam('lang'))){
            $lang = $config_fe->languages->{0};       
        }
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->doCheckParents(false)
                         ->get($uid, $lang, true);
                
        $filter = new Simploo_Filter_Sistrip();
        $name = $filter->filter($name);
        $filter = new Zend_Filter_StripTags();
        $name = $filter->filter($name);  
        
        $this->view->renamed = $mNodes->rename($node, $name);
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu', 'draft')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->renamed);
            die();
        }  
    }
    
    public function removeAction()
    {
        $data = array();
        
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $uid = intval($this->getRequest()->getparam('uid')); 
        if(!($lang = $this->getRequest()->getParam('lang'))){
            $lang = $config_fe->languages->{0};       
        }
        
        
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->doCheckParents(false)
                         ->get($uid, $lang, true);
        $parentUid = $node->getTree()->parent->value(); 
        
        $data['status'] = $mNodes->remove($node);
        if($this->getRequest()->getparam('getversions')){
            //$mVersions = new Sicore_Models_Server_Db_Version();
            //$this->view->versions = $mVersions->getByPage($parentUid);
            $data['versions']     = count($this->view->versions) ? $this->view->render('menu/versions.phtml') : ''; 
        }
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu', 'draft')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        }  
    }
    
    public function versionsAction(){
        $data = array();
        
        $page   = intval($this->getRequest()->getparam('page')); 
        $limit  = intval($this->getRequest()->getparam('limit', 10));
        
        //$mVersions = new Sicore_Models_Server_Db_Version();
        //$this->view->versions = $mVersions->getByPage($page, 0, $limit);
        $data['versions']     = count($this->view->versions) ? $this->view->render('menu/versions.phtml') : ''; 
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        } 
    }
    
    public function createAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidDest   = intval($this->getRequest()->getparam('uidDest')); 
        $name      = base64_decode(urldecode($this->getRequest()->getparam('name')));
        $mode      = $this->getRequest()->getparam('mode') == 'after' ? 'after' :'inside' ; 
        if(!($lang = $this->getRequest()->getParam('lang'))){
            $lang = $config_fe->languages->{0};       
        }
        
        $mNodes     = new Sicore_Models_Server_Db_Nodes();
        $nodeDest   = $mNodes->get($uidDest, $lang, true);
        
        $this->view->newid = $mNodes->create($nodeDest, $name, $mode, 'Sicore_Models_Node_Page', $ident->generateFlag(), $lang);
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu', 'draft')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->newid);
            die();
        }

    }
    
    public function moveAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidSource = intval($this->getRequest()->getparam('uidSource'));   
        $uidDest   = intval($this->getRequest()->getparam('uidDest'));  
        $type      = $this->getRequest()->getparam('type');
        if(!($lang = $this->getRequest()->getParam('lang'))){
            $lang = $config_fe->languages->{0};       
        }
        
        $mNodes     = new Sicore_Models_Server_Db_Nodes();
        $nodeSource = $mNodes->get($uidSource, $lang, true);
        $nodeDest   = $mNodes->get($uidDest,   $lang, true);

        $this->view->moved = $mNodes->move($nodeSource, $nodeDest, $type);
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->moved);
            die();
        }
    }
    
    public function copyAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $uidSource = intval($this->getRequest()->getparam('uidSource'));   
        $uidDest   = intval($this->getRequest()->getparam('uidDest'));
        $type      = $this->getRequest()->getparam('type');
        if(!($lang = $this->getRequest()->getParam('lang'))){
            $lang = $config_fe->languages->{0};       
        }
       
        $mNodes     = new Sicore_Models_Server_Db_Nodes();
        $nodeSource = $mNodes->get($uidSource, $lang, true);
        $nodeDest   = $mNodes->get($uidDest,   $lang, true);
 
        $this->view->copied = $mNodes->copy($nodeSource, $nodeDest, $type, $ident->generateFlag());
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu', 'draft')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->copied);
            die();
        }
    }
    
    public function undoAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $uid        = intval($this->getRequest()->getparam('uid'));   
        
        $mNodes    = new Sicore_Models_Server_Db_Nodes();
        $node      = $mNodes->get($uid, 'de', true);
                
        $isUndo    = $mNodes->undo($node);
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu')
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($isUndo);
            die();
        }
    }
    
    public function cachecleanAction()
    {
        $uid    = intval($this->getRequest()->getparam('uid')); 
        $all    = intval($this->getRequest()->getparam('all')); 
        
        $tags   = $all ? array('content') : array('content', (string)$uid);
        
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            $tags
        );
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode(true);
            die();
        }
    }
    
    public function getunpublishedAction()
    {
        
        $uid    = intval($this->getRequest()->getparam('uid')); 
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $page   = $mNodes->getByUid($uid);
        
        if(!($page instanceof Sicore_Models_Node)){
            echo Zend_Json::encode(array('status' => false, 'data' => null));  
            die();
        }
        
        $pages = $mNodes->doCheckIsHidden(false)
                               ->doCheckIsDeleted(false)
                               ->doCheckIsActive(false)
                               ->doCheckDate(false)
                               ->getByParentUid($page->getTree()->parent->value(), array('Sicore_Models_Node_Page'), array(), true, 0, true);
        if(!$pages){
            echo Zend_Json::encode(array('status' => false, 'data' => null));   
            die();
        }
         
        $data = array();
        foreach($pages as $page){
            if($page->uid->value() == $uid) continue;
            $data[$page->uid->value()] = $page->title->value(); 
        }
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            if(count($data)){
                echo Zend_Json::encode(array('status' => true, 'data' => $data));
            }else{
                echo Zend_Json::encode(array('status' => false, 'data' => null));
            }
            die();
        } 
    }
    
    
    public function publishAction()
    {
        
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        $uid       = intval($this->getRequest()->getparam('uid')); 
        $subpages  = intval($this->getRequest()->getparam('subpages')); 
        $pages     = $this->getRequest()->getparam('pages');
        
        $mNodes    = new Sicore_Models_Server_Db_Nodes();
        try{  
            $node  = $mNodes->get($uid, 'de', true);
        }catch(Exception $e){
            echo Zend_Json::encode(false);
            die();
        }
                    
        $isPublish = $mNodes->publish($node, false, $subpages);
        if($pages){
            $uids = explode(',', $pages);
            foreach($uids as $uid){
                try{
                    $node = $mNodes->get($uid, 'de', true);
                }catch(Exception $e){
                    continue;
                }
                $mNodes->publish($node, false, $subpages); 
            }
        }
        $cache = Sicore_Models_Registry::getCache();
        $cache->clean(
            Zend_Cache::CLEANING_MODE_MATCHING_TAG,
            array('menu')
        );
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($isPublish);
            die();
        }
    }
    
    public function insertlinkAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();
        
        $node = null;
        
        try{
            $uid    = intval($this->getRequest()->getparam('uid')); 
            $mNodes = new Sicore_Models_Server_Db_Nodes();
            $node   = $mNodes->setDraft(true)
                             ->doCheckParents(false) 
                             ->doCheckIsDeleted(false)
                             ->doCheckIsActive(false)
                             ->doCheckDate(false)
                             ->getByUid($uid);
            $title = $node->title->value();
            $uid   = $node->uid->value();
        }catch(Sifront_Models_Exception_Pagenotfound $e){
            $uid = '';
            $title = '';
        }   
        $data = array(); 
        
        if ($this->_request->isPost()){          
            
            if(!$node){
                $data['saved']    = false;
                $data['errors'][] = $translate->_('E_GENERAL_LINKTARGET');
                $data['fields'][] = 'name';
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                $data['type']   = 'node'; 
                $data['href']   = (string)$this->view->link($node);
                $data['uid']    = $uid;      
                $target = str_replace('"', '', strip_tags($this->getRequest()->getparam('target'))); 
                $title  = str_replace('"', '', strip_tags($this->getRequest()->getparam('title'))); 
                $data['target'] = $target;
                $data['title']  = $title; 
                $data['saved']  = true;
            }      
        }else{
            $path   = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);    
            $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
            $form   = new Sicore_Models_Gui_Form_Link(Sicore_Models_Gui_Form_Link::PAGE,
                                                      $uid,
                                                      $title
                                                     );
            $form->setAction($path.'sicore/pages/insertlink');
            $data['title']        = $title;
            $data['labelInsert']  = $this->view->translate('GENERAL_INSERT'); 
            $data['labelDelete']  = $this->view->translate('GENERAL_DELETELINK'); 
            $data['content']      = $form->render();   
            $data['scripts'][]    = "$('#tabContainer').tabs({
                                                                select: function(event, ui) { 
                                                                    if(ui.index == 1){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertexternallink');
                                                                    }else if(ui.index == 2){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertemaillink');
                                                                    }else{
                                                                        $('#si_blackbox1').css('z-index', 500);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertlink'); 
                                                                    }
                                                                 }
                                                               });
                                    ";
        }
            
        echo Zend_Json::encode($data);
        die();
    }
    
    public function insertexternallinkAction(){
        $translate = Sicore_Models_Registry::getTranslate();
        
        $data = array();
        if ($this->_request->isPost()){          
            if(!($url = Sicore_Models_Helper_Link::getExternalLink($this->getRequest()->getparam('extern_url')))){
                $data['saved']    = false;
                $data['errors'][] = $translate->_('E_GENERAL_LINKURL'); 
                $data['fields'][] = 'extern_url';
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT');    
            }else{
                $data['type']   = 'extern'; 
                $data['href']   = $url;
                $data['uid']    = '';        
                $target = str_replace('"', '', strip_tags($this->getRequest()->getparam('extern_target'))); 
                $title  = str_replace('"', '', strip_tags($this->getRequest()->getparam('extern_title'))); 
                $data['target'] = $target;
                $data['title']  = $title; 
                $data['saved']  = true;
            }  
       }else{
            $path   = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);    
            $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
            $form   = new Sicore_Models_Gui_Form_Link(Sicore_Models_Gui_Form_Link::EXTERNAL);
            
            $form->setAction($path.'sicore/pages/insertexternallink');
            $data['title']        = $this->view->translate('GENERAL_INSERTLINK_EXTERN'); 
            $data['labelInsert']  = $this->view->translate('GENERAL_INSERT'); 
            $data['labelDelete']  = $this->view->translate('GENERAL_DELETELINK');
            $data['content']      = $form->render();
            $data['scripts'][]    = "$('#tabContainer').tabs({
                                                                select: function(event, ui) { 
                                                                    if(ui.index == 1){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertexternallink');
                                                                    }else{
                                                                        $('#si_blackbox1').css('z-index', 500);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertlink'); 
                                                                    }
                                                                 }
                                                               });
                                    ";           
       }
       echo Zend_Json::encode($data);
       die(); 
    }
    
    public function insertemaillinkAction(){
        $translate = Sicore_Models_Registry::getTranslate();
        
        $data = array();
        if ($this->_request->isPost()){          
            if(!($email = Sicore_Models_Helper_Link::getEmailLink($this->getRequest()->getparam('email_url')))){
                $data['saved']    = false;
                $data['errors'][] = $translate->_('E_GENERAL_EMAIL'); 
                $data['fields'][] = 'email_url';
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT');    
            }else{
                $data['type']   = 'email'; 
                $data['href']   = $email;
                $data['target'] = null; 
                $data['uid']    = '';         
                $data['title']  = str_replace('"', '', strip_tags($this->getRequest()->getparam('email_title')));
                $data['saved']  = true;
            }  
       }else{
            $path   = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);    
            $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
            $form   = new Sicore_Models_Gui_Form_Link(Sicore_Models_Gui_Form_Link::EMAIL);
            
            $form->setAction($path.'sicore/pages/insertemaillink');
            $data['title']        = $this->view->translate('GENERAL_INSERTLINK_EMAIL'); 
            $data['labelInsert']  = $this->view->translate('GENERAL_INSERT'); 
            $data['labelDelete']  = $this->view->translate('GENERAL_DELETELINK');
            $data['content']      = $form->render();
            $data['scripts'][]    = "$('#tabContainer').tabs({
                                                                select: function(event, ui) { 
                                                                    if(ui.index == 1){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertexternallink');
                                                                    }else if(ui.index == 2){
                                                                        $('#si_blackbox1').css('z-index', 2000);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertemaillink');
                                                                    
                                                                    }else{
                                                                        $('#si_blackbox1').css('z-index', 500);
                                                                        $('#si_edit_main').attr('action', '".$path."sicore/pages/insertlink'); 
                                                                    }
                                                                 }
                                                               });
                                    ";           
       }
       echo Zend_Json::encode($data);
       die(); 
    }
    
    public function editAction(){
    
        $uid    = intval($this->getRequest()->getparam('uid')); 
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->setDraft(true)
                         ->doCheckParents(false) 
                         ->doCheckIsDeleted(false)
                         ->doCheckIsActive(false)
                         ->doCheckDate(false)
                         ->getByUid($uid);
                         

        $form   = new Sicore_Models_Gui_Form_Backend($node, $this->user, true);
        $path   = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $form->setAction($path.'sicore/pages/save');
        
        $data = array();
        $data['labelSave']        = $this->view->translate('GENERAL_SAVE');
        $data['labelSaveOpen']    = $this->view->translate('GENERAL_SAVEOPEN'); 
        $data['labelSavePublish'] = $this->view->translate('GENERAL_SAVEPUBLISH');
        $data['actionSave']       = $path.'sicore/pages/save'; 
        $data['actionSaveOpen']   = $path.'sicore/pages/save/mode/open';
        $data['actionSavePublish']= $path.'sicore/pages/save/mode/publish';
        $data['title']      = $node->title->value(); 
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';
   
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function saveAction(){

        $translate = Sicore_Models_Registry::getTranslate();
        
        if($this->getRequest()->isPost()){
            $formData = $this->getRequest()->getPost();
            $uid = intval($this->getRequest()->getParam('uid')); 
             
            $mNodes = new Sicore_Models_Server_Db_Nodes();
            $node   = $mNodes->setDraft(true)
                             ->doCheckParents(false) 
                             ->doCheckIsDeleted(false)
                             ->doCheckIsActive(false)
                             ->doCheckDate(false)
                             ->getByUid($uid);
                             
            $form   = new Sicore_Models_Gui_Form_Backend($node, $this->user);
            $data = array();
            if (!$form->isValid($formData)) {
                $errors = $form->getBackendErrors();   
                $data['saved']  = false;
                $data['errors']    = $errors['errors'];
                $data['fields']    = $errors['fields'];
                $data['subforms']  = $errors['subformIndexs'];    
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                $elements = $form->getElementsToSave();
                $node->init($elements);
 
                if($mNodes->update($node)){
                    $data['saved'] = true;
                    $data['uid']   = $node->uid->value(); 
                    $data['mode']  = $this->getRequest()->getParam('mode'); 
                    $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
                    $cache = Sicore_Models_Registry::getCache();
                    $cache->clean(
                        Zend_Cache::CLEANING_MODE_MATCHING_TAG,
                        array('menu', 'draft')
                    );
                }else{  
                    $data['saved']  = false;
                    $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_UNKOWN'); 
                } 
                  
            }
            
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function rootlineAction()
    {
        $data = array();
        
        $translate = Sicore_Models_Registry::getTranslate(); 
        $page  = intval($this->getRequest()->getParam('page'));
        $lang  = $this->getRequest()->getParam('lang', 'de');
        $draft = $this->getRequest()->getParam('draft', 0);
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->get($page, $lang, $draft);
        foreach($node->getAllParents()  as $parent){
            $canEdit = $parent->caneditpage->check($this->user);
            $data[] = array('uid' => $parent->uid->value(), 'title' => $parent->title->value(), 'subtitle' => $canEdit ? null : $translate->_('GENERAL_NO_RIGHTS'), 'canEdit' => $canEdit);
        } 
        if(!count($data)){
            $data[]  = array('uid' => $node->uid->value(), 'title' => $node->title->value(), 'subtitle' => $translate->_('GENERAL_ALL_PAGES'), 'canEdit' => true); 
        }else{
            $data[0]['subtitle'] = $translate->_('GENERAL_ALL_PAGES');
            $data[]  = array('uid' => $node->uid->value(), 'title' => $node->title->value(), 'subtitle' => $translate->_('GENERAL_CURRENT_PAGE'), 'canEdit' => true); 
        }
        
        echo Zend_Json::encode($data);
        die();
    }
    
    public function undopropertyAction()
    { 
        $data = array('status' => 'ok');
        
        if(!($page = intval($this->getRequest()->getParam('rootuid')))){
            $page    = intval($this->getRequest()->getParam('page')); 
        }
        
        $language = $this->getRequest()->getParam('lang');
        $property = $this->getRequest()->getParam('property');
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->setDraft(true)
                         ->doCheckParents(false) 
                         ->doCheckIsDeleted(false)
                         ->doCheckIsActive(false)
                         ->doCheckDate(false)
                         ->getByUid($page);
        
        $mNodes   = new Sicore_Models_Server_Db_Nodes();
        $mNodes->undo($node, true);

        echo Zend_Json::encode($data);
        die();    
    }
    
    public function savepropertyAction()
    {
        $data = array();
        $data['saved'] = false;
        if($this->getRequest()->isPost()){ 
            if(!($page = intval($this->getRequest()->getParam('rootuid')))){
                $page    = intval($this->getRequest()->getParam('page')); 
            }
            $doDeleteSubfields = (bool)$this->getRequest()->getParam('deletesubfields');
            $doPublish         = (bool)$this->getRequest()->getParam('publish');  
            $property          = $this->getRequest()->getParam('property');
            
            $mNodes = new Sicore_Models_Server_Db_Nodes();
            $node   = $mNodes->setDraft(true)
                             ->doCheckParents(false) 
                             ->doCheckIsDeleted(false)
                             ->doCheckIsActive(false)
                             ->doCheckDate(false)
                             ->getByUid($page);
           
            if(!($node && $node->$property instanceof Sicore_Models_Node_Property)){
                $data['error'] = 'Node '.$page.' or property '.$property.' not defined'; 
                Sicore_Models_Logger::error($data['error']);
                echo Zend_Json::encode($data);
                die();
            }
            
            if($doDeleteSubfields){
                $node->publishdeletesubfields->add($node->$property->field(), $node->$property->field());
                $mNodes->deleteSubfields($page, $node->$property->field(), true); 
            }
            
            $post = $this->getRequest()->getParam('si_content_property_changed');
            if(!base64_decode($post[$property])){
                $node->$property->set('');  
            }else{
                $node->$property->set(base64_decode($post[$property]));  
            } 
            
            $node->publishfield->set($node->$property->field());  
            if($mNodes->update($node)){
                if($doPublish){
                    $mNodes->publish($node, true);
                    if($doDeleteSubfields) $mNodes->deleteSubfields($page, $node->$property->field(), false);
                }
                
                $data['saved'] = true;
                if($this->getRequest()->getparam('getversions') && !intval($this->getRequest()->getParam('rootuid'))){
                    $data['versions']     = count($this->view->versions) ? $this->view->render('menu/versions.phtml') : ''; 
                }
            }
        } 
           
        echo Zend_Json::encode($data);
        die();
    }
    
    public function droppageAction()
    {
        $data = array();
        
        $uid  = intval($this->getRequest()->getParam('uid'));
        $page = intval($this->getRequest()->getParam('page'));
        $lang = $this->getRequest()->getParam('lang');
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $node   = $mNodes->get($uid, $lang, true);
        
        $mLink = new Sicore_Models_Helper_Link();
        if(!($link  = $mLink->getByUid($uid))){
            return;
        }

        $data['content'] = '<a type="node" uid="'.$uid.'" href="'.$link.'>'.$node->title->value().'</a>';
        echo Zend_Json::encode($data);
        die();
    }
         
}