<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist fr Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * bentigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fllen mssen Sie ber www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Simploo.php 1220 2010-03-03 08:05:02Z ms $
 */
class Sicore_Controllers_Simploo extends Zend_Controller_Action
{
    protected $config_backend = null;
    protected $config_base    = null;
    protected $user           = null; 
    protected $sico           = null; 
    protected $se             = null; 
    
    public function preDispatch()
    {

        $controller     = $this->getRequest()->getControllerName();
        $action         = $this->getRequest()->getActionName();             
        
        foreach($this->config_backend->notprotected as $np_controller => $actions){
            foreach($actions as $np_action => $protected){
                if(!$protected) continue;     
                if($np_controller == $controller && $np_action == $action){
                    return;
                }
            }
        }
        
        $this->user = Zend_Auth::getInstance()->getIdentity();
        
        if(!Zend_Auth::getInstance()->hasIdentity()){
           $this->_forward('login', 'user'); 
           return;
        }         
    }
    
    public function init()
    {
        $this->config_backend  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BACKEND); 
        $this->config_base     = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        
        $this->sico            = new Sicore_Models_Core();
        $this->se              = $this->config_base->app->serial;

        $this->view->setEncoding('utf-8'); 
        ZendX_JQuery::enableView($this->view); 
               
        //View Script-Pfade
        $this->view->setScriptPath('templates/backend');
        $this->view->addScriptPath("templates/backend/".$this->config_backend->layout);     
        
        //View-Helper Script-Pfade  
        foreach($this->config_base->general->modules as $module){
            $this->view->addHelperPath("application/$module/Views/Helpers", "${module}_Views_Helpers");     
        }
        $this->view->addHelperPath("Simploo/JQuery/View/Helper", "Simploo_JQuery_View_Helper");
        $this->_helper->contextSwitch()->setAutoJsonSerialization(false); 
        $this->_helper->contextSwitch()->initContext();
        
        $this->view->request = $this->getRequest();
                
        Sicore_Models_Gui::setView($this->view);
        Sicore_Models_Gui::setConfigBase($this->config_base);
        Sicore_Models_Gui::setConfigBackend($this->config_backend);        
    }
    
     
}