<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Clipboard.php 1504 2010-08-17 16:35:17Z ms $
 */
class Sicore_Models_Clipboard{
    
    public static function addPage($uid, $parent, $sorting, $name = '')
    {
        self::add('pages', $uid, $parent, $sorting, $name); 
        return self::get();   
    }
    
    public static function addContent($uid, $parent, $sorting, $name = '')
    {
        self::add('content', $uid, $parent, $sorting, $name);
        return self::get();
    }
    
    public static function filled()
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');  
        return count($namespace->content) || count($namespace->pages);
    }
    
    public static function get()
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');
        $data = array('pages'      => array(),
                      'pageslen'   => 0,
                      'content'    => array(),
                      'contentlen' => 0
                     );
        if(is_array($namespace->content)){
            $data['content']    = $namespace->content;
            $data['contentlen'] = count($namespace->content);    
        }
        if(is_array($namespace->pages)){
            $data['pages']    = $namespace->pages;    
            $data['pageslen'] = count($namespace->pages);
        }
        
        return $data;
    }
    
    public function deleteContent($key)
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');
        $content   = $namespace->content;
        unset($content[$key]);
        $namespace->content = $content;
        
        self::get();
    }
    
    public function deletePage($key)
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');
        $pages     = $namespace->pages;
        unset($pages[$key]);
        $namespace->pages = $pages;
        
        self::get();
    }
    
    public static function clear()
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');
        unset($namespace->content); 
        unset($namespace->pages);
    }
    
    protected static function add($key, $uid, $parent, $sorting, $name)
    {
        $namespace = new Zend_Session_Namespace('Simploo_Clipboard');
        
        if(!is_array($namespace->$key)){
            $namespace->$key = array();    
        }
        $sorting = str_pad($sorting, 5, 0, STR_PAD_LEFT);
        
        $pages       =  $namespace->$key;
        foreach($pages as $sortkey => $value){
            if($value['uid'] == $uid) return;
        }  
        $pages[$parent.'_'.$sorting.'_'.$uid] = array('uid' => $uid, 'name' => $name);
        ksort($pages);
        
        $namespace->$key = $pages;
         
    }
}

