<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Core.php 1351 2010-05-21 16:28:53Z ms $
 */
class Sicore_Models_Core
{
    public static $config = null;
    const  COM = 768;
    const  BIZ = 668;
    
    public static function lc($s, $acceptDev = false)
    {
        if(empty($s) && $acceptDev){
            return true;
        }elseif(empty($s)){
            return false; 
        }
        $st = explode('-', $s);
        if(count($st) != 4) return false; 
        $r = array();
        for($i = 1; $i <= 2; $i++){
            $r[$i] = 0;
            $t = (string)$st[$i];
            for($ii = 0; $ii < strlen($t); $ii++){
                $r[$i] += intval($t[$ii]);
            }

        }
        //Zend_Debug::dump($st);
        $eq = (string)($st[0] * $r[1] * $r[2] / 2);

        if((string)$st[3] != substr($eq, 0, 3)) return false;
        if(self::$config instanceof Zend_Config){
            $config_base = self::$config;
        }else{
            $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        }
        $v = intval(substr($s, 0, 3)) - intval(substr($config_base->app->release, 0, 1));
        if($v != self::BIZ && $v != self::COM) return false;
       
        return true;
    }
    
    public static function isb($serial)
    {
        if(empty($serial)) return false;
        $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        
        $serial = intval(substr($serial, 0, 3)) - intval(substr($config_base->app->release, 0, 1));
        if($serial == self::COM) return false;
       
        return true;  
    }
    
    public static function le($s)
    {
        if(!self::lc($s)) return 100;
        
        if(self::$config instanceof Zend_Config){
            $config_base = self::$config;
        }else{
            $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        }
        $v = intval(substr($config_base->app->release, 0, 1));
        return intval(substr($s, 0, 3)) - $v;
    } 
    
    public static function ac($a)
    {
        $a  = base64_decode($a);
        $ap = explode('####', $a);
        if(count($ap) != 3) return -1;
        if(strlen($ap[1]) != 8 || strlen($ap[2]) != 6) return -1;
        if(!self::lc($ap[0])) return -2;
        
        return 1;
    }
    
    public static function gac($s, $k, $i)
    {
        return str_replace('=', '', base64_encode("$s####$k####$i"));
    }
    
    public static function ae($a)
    {
        $a  = base64_decode($a);
        $ap = explode('####', $a);
        if(count($ap) != 3) return false;
        $k = array();
        $st = explode('-', $ap[0]); 
        $k[0] = $ap[2]; 
        $k[1] = $ap[0];
        $k[2] = $ap[1];
        
        return $k;    
    }
    
    public static function genb($major = 1)
    {
        return self::_gen(self::BIZ + $major);    
    }
    
    public static function genc($major = 1)
    {
        return self::_gen(self::COM + $major);    
    }
    
    protected static function _gen($part1)
    {
        srand ((double) microtime() * 1000000);
        $part2 = str_pad(rand(0,1000), 3, '0'); 
        $part3 = str_pad(rand(0,1000), 3, '0');  
        
        $part4 = substr(($part1 * self::_crossfoot($part2) * self::_crossfoot($part3)) / 2, 0, 3);
        
        return "$part1-$part2-$part3-$part4";  
    }
    
    protected function _crossfoot($number)
    {
        $number    = (string)$number;
        $crossfoot = 0;
        for($crossfoot = $i = 0; $i < strlen ($number); $i++ ){
            $crossfoot += $number{$i};
        }
        return $crossfoot; 
    }
    
    
    public function __call($name, $arguments)
    {
        return self::lc($arguments[0]);
    }
      
}

