<?php
    /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Images.php 1544 2010-09-22 16:15:54Z ms $
 */
class Sicore_Models_Gui_Form_Design_Images extends Sicore_Models_Gui_Form
{
    protected $_user       = null;
    protected $_template   = null;  
    
    const IDPREFIX = 'siform_'; 
    
    public function __construct(Sicore_Models_Template_Local $template, $user)
    {        
        $this->_template   = $template;
        $this->_user       = $user;  
        
        parent::__construct();
    }
    
    public function init()
    {
        
        $this->setAttrib('id',     'si_edit_main'); 
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setDecorators(array(
            'FormElements',
            array('TabContainer', array(
                'id'          => 'tabContainer'
            )),
            'Form',
        ));
        
        //INTERN
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_edit_main',
                                                'title' => $translate->_('GENERAL_IMAGES'))))
        ));
        
        
        
        foreach($this->_template->getImagesAsArray() as $key => $config){
            if($config['deletable']){
                $element = new Zend_Form_Element_Checkbox('delete_'.$key);
                $element->setLabel($translate->_($config['title']).' '.$translate->_('LL_IMAGE_DELETE'));
                $element->removeDecorator('HtmlTag');
                $element->addDecorator('Label'); 
                $element->addDecorator('Description');  
                $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
                $subForm->addElement($element, 'delete_'.$key);
            }
            $element = new Simploo_JQuery_Form_Element_Drop($key);  
            $element->setLabel($translate->_($config['title']).' '.$translate->_('LL_IMAGE_CHANGE'));
            $element->setAttrib('dropzone', 'Sicore_Models_FSO_File_Image'); 
            $element->setAttrib('id', self::IDPREFIX.$key);  
            if(empty($config['description'])){
                $element->setDescription($translate->_('GENERAL_NODE_DROP_IMAGES'));
            }else{
                $element->setDescription($translate->_($config['description'])); 
            }
            if($config['required']) $element->setRequired(true);
            $element->removeDecorator('HtmlTag');
            $element->addDecorator('Label'); 
            $element->addDecorator('Description');  
            $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
            $subForm->addElement($element, $key);
        }
        $element = new Zend_Form_Element_Hidden('folder');
        $element->setAttrib('id', self::IDPREFIX.'folder');  
        $element->setValue($this->_template->getFolder());
        $subForm->addElement($element, 'folder'); 
        $subForm->addElement('hash', 'si_hash_', array('salt' => 'unique'));         
        $this->addSubForm($subForm, 'general');
        
        
    }   
}