<?php
  /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Loggingoptions.php 1544 2010-09-22 16:15:54Z ms $
 */
class Sicore_Models_Gui_Form_Settings_Loggingoptions extends Sicore_Models_Gui_Form
{
    protected $_user     = null;
    protected $_config   = null; 
    protected $_editmode = true;
    
    const IDPREFIX = 'siform_'; 
    
    public function __construct(Zend_Config $config, $user, $editmode = true)
    {        
        $this->_user     = $config;
        $this->_config   = $config; 
        $this->_editmode = $editmode; 
        
        parent::__construct();
    }
    
    public function init()
    {
        
        $this->setAttrib('id',     'si_edit_main'); 
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setDecorators(array(
            'FormElements',
            array('TabContainer', array(
                'id'          => 'tabContainer'
            )),
            'Form',
        ));
        
        //INTERN
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_edit_main',
                                                'title' => $translate->_('SETTINGS_LOGGING_OPTIONS'))))
        ));
        
        
        
        $element = new Zend_Form_Element_Checkbox('feout');
        $element->setChecked($this->_config->logging->feout); 
        if(!$this->_editmode) $element->setAttrib('disabled', 'disabled'); 
        $element->setLabel($translate->_('SETTINGS_LOGGING_FEOUT'));
        $element->setAttrib('id', self::IDPREFIX.'uid');  
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label'); 
        $element->addDecorator('Description');   
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));  
        $subForm->addElement($element, 'feout');
        
        $element = new Zend_Form_Element_Checkbox('information');
        $element->setChecked($this->_config->logging->info); 
        if(!$this->_editmode) $element->setAttrib('disabled', 'disabled'); 
        $element->setLabel($translate->_('SETTINGS_LOGGING_INFORMATION'));
        $element->setAttrib('id', self::IDPREFIX.'uid');  
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label'); 
        $element->addDecorator('Description');   
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));  
        $subForm->addElement($element, 'information');
        
        $element = new Zend_Form_Element_Checkbox('error');
        $element->setChecked($this->_config->logging->error);
        if(!$this->_editmode) $element->setAttrib('disabled', 'disabled'); 
        $element->setLabel($translate->_('SETTINGS_LOGGING_ERROR'));
        $element->setAttrib('id', self::IDPREFIX.'uid');
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label'); 
        $element->addDecorator('Description');  
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));  
        $subForm->addElement($element, 'error');
        
        $element = new Zend_Form_Element_Checkbox('exception');
        $element->setChecked($this->_config->logging->exception); 
        if(!$this->_editmode) $element->setAttrib('disabled', 'disabled'); 
        $element->setLabel($translate->_('SETTINGS_LOGGING_EXCEPTION'));
        $element->setAttrib('id', self::IDPREFIX.'uid'); 
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label'); 
        $element->addDecorator('Description');  
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));  
        $subForm->addElement($element, 'exception');
        
        $subForm->addElement('hash', 'si_hash_', array('salt' => 'unique'));  
        
        $this->addSubForm($subForm, 'general');
        
        
    }   
}