<?php
 /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Tableedit.php 1503 2010-08-04 09:00:02Z ms $
 */
class Sicore_Models_Gui_Form_Tableedit extends Sicore_Models_Gui_Form
{
    
    protected $_cols = null;
    
    const IDPREFIX = 'siform_';
            
    public function __construct($cols = 1)
    {        
        $this->_cols   = intval($cols);
        parent::__construct();
    }
    
    public function init()
    {
        
        $this->setAttrib('id',     'si_edit_main'); 
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setDecorators(array(
            'FormElements',
            array('TabContainer', array(
                'id'          => 'tabContainer'
            )),
            'Form',
        ));
        

        //VIDEO
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_edit_main',
                                                'title' => $translate->_('GENERAL_TABLEEDIT'))))
        ));
        
        for($i = 1; $i <= $this->_cols; $i++){
            $element = new Zend_Form_Element_Text('width_'.$i);
            $element->setAttrib('class', 'si_small');
            $element->addFilter(new Simploo_Filter_StripSlashes()); 
            $element->setLabel($translate->_('GENERAL_WIDTH_COL').' '.$i);
            $element->removeDecorator('HtmlTag');
            $element->addDecorator('Label');  
            $element->addDecorator('Description'); 
            $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
            $element->setAttrib('id', self::IDPREFIX.'width_'.$i); 
            $subForm->addElement($element, 'width_'.$i); 
        }
        
        $element = new Zend_Form_Element_Text('css');
            $element->setAttrib('class', 'si_small');
            $element->addFilter(new Simploo_Filter_StripSlashes()); 
            $element->setLabel($translate->_('GENERAL_CSS'));
            $element->removeDecorator('HtmlTag');
            $element->addDecorator('Label');  
            $element->addDecorator('Description'); 
            $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
            $element->setAttrib('id', self::IDPREFIX.'css'); 
            $subForm->addElement($element, 'css');  
        /* 
        $element = new Zend_Form_Element_Select('size');
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->setLabel('GENERAL_SIZE');
        $config_base  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        if($config_base->video->sizes){
            foreach($config_base->video->sizes as $label => $value){
                if(($label = $translate->_('GENERAL_YOUTUBE_SIZES_'-strtoupper($label))) ==  'GENERAL_YOUTUBE_SIZES_'-strtoupper($label)){
                    $label = "$value Pixel";
                }
                $element->addMultiOption($value, $label);        
            }    
        }else{
            $element->addMultiOption('480x295', '480x295 Pixel'); 
        } 

        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');  
        $element->addDecorator('Description'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $subForm->addElement($element, 'size'); 
        */
        $this->addSubForm($subForm, 'tableedit');
        
    }   
}