<?php
   /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Upload.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Gui_Form_Upload extends Sicore_Models_Gui_Form
{
    protected $_folder = null;
    
    public function __construct(Sicore_Models_FSO_Folder $folder)
    {
        $this->_folder = $folder;
        
        parent::__construct();
    }
    
    public function init()
    {
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setAttrib('id', 'si_upload_main');  
        $this->setDecorators(array(
                'FormElements',
                array('TabContainer', array(
                    'id'          => 'tabContainer'
                )),
                'Form',
            ));
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_upload_main',
                                                'title' => 'GENERAL_UPLOAD_TITLE')))
        ));  
                
        $this->setEnctype('multipart/form-data');
        
        //$this->clearDecorators();
        
        $id = $this->_folder->uid;
        $element   = new Simploo_JQuery_Form_Element_Upload("$id");
        $element->removeDecorator("Label");
        $element->removeDecorator('HtmlTag');   
        $subForm->addElement($element, 'upload'); 

        $this->addSubForm($subForm, 'upload');
    }   
}