<?php
  /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Menu.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Gui_Menu extends Sicore_Models_Gui
{   
    /**
     * DESCRIPTION
     *
     * @param TYPE $name
     * @return TYPE
     */
    public function __construct()
    {
        parent::__construct('menu/show', null, 'menu.css');     
    }
    
    public function init()
    {
        $this->loadMenuItems();
        
        $this->addAlternateStylesheet('menu_ie.css', 'IE');        
        parent::init();
             
    }
    
    protected function loadMenuItems()
    {
        $items = array();
        $user = Sicore_Models_Registry::getUser();
        if($user->isadmin->value()){
            $menus = self::$_config_backend->modules->toArray();    
        }else{
            $menus = $user->getGuiMenu();
        }
        
        foreach($menus as $menu){
            try{
                if(empty($menu)) continue;        
                $mMenu = new $menu();
            }catch(Exception $e){
                Sicore_Models_Logger::exception($e); 
                continue;
            }
            if(!($mMenu instanceof Sicore_Models_Gui_Menu_Interface)){
                continue;
            }
            $mMenu->appendFilesToView();
            $items[] = $mMenu;
        }
        self::$_view->assign('items', $items); 
    }
}