<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Helper
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Messages.php 1207 2010-02-27 19:03:54Z ms $
 */

class Sicore_Models_Helper_Messages
{
    
    protected static $_messages;
    
    const ERROR    = 'si_error';
    const MESSAGE  = 'si_message';
    const WARNING  = 'si_warning';
    
    public static function set($key, $message, $mode = self::MESSAGE){
        $msg = new stdClass();
        $msg->key   = $key;
        $msg->text  = $message;
        $msg->class = $mode; 
        self::$_messages[$key] = $msg;     
    }
    
    public static function getText($key)
    {
        return isset(self::$_messages[$key]) ? self::$_messages[$key]->text : '';
    }
    
    public static function getClass($key)
    {
        return isset(self::$_messages[$key]) ? self::$_messages[$key]->class : self::MESSAGE;
    }
    
    public static function has($key)
    {
        return isset(self::$_messages[$key]);
    }
}
?>
