<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Datetime.php 1432 2010-06-16 17:43:02Z ms $
 */
class Sicore_Models_Node_Property_Datetime extends Sicore_Models_Node_Property
                                          implements Sicore_Models_Node_Property_Database_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        if(empty($value)){
            $this->_value = '';
            return;
        }
        
        if($value instanceof Zend_Date){
            $this->_value = $value;
        }elseif($value instanceof Zend_Db_Expr){
            $this->_value = $value;     
        }else{
            $this->_value = new Zend_Date($value);
        } 
        
        $this->_rootUid = $rootUid;
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields;     
    }
    
    public function toDatabase(Array $data){
        if($this->_value instanceof Zend_Date){
            $data[$this->field()] = $this->_value->getIso();
        }elseif($this->_value instanceof Zend_Db_Expr){
            $data[$this->field()] = $this->_value; 
        }
        return $data;
    }
    
    public function value($mode = null)
    {
        if(!($this->_value instanceof Zend_Date)){
            return;
        }
        
        if($mode){
            return $this->_value->get($mode); 
        }else{
            return $this->_value;     
        }
        
    }
}
?>
