<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Decimal.php 1208 2010-02-27 19:07:04Z ms $
 */
class Sicore_Models_Node_Property_Decimal extends Sicore_Models_Node_Property
                                          implements Sicore_Models_Node_Property_Database_Interface{
    
    const STANDARD = 0;
    const FILESIZE = 1;
                                              
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        $this->_value = (float)$value;
        $this->_rootUid = $rootUid;   
        $this->_canPublish = (bool)$canPublish;
        $this->_deleteSubfields = (bool)$deleteSubfields;   
    }
    
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->value();
        return $data;
    }
    
    public function value($type = self::STANDARD)
    {
        $translate = Sicore_Models_Registry::getTranslate();
        switch($type){
            case self::FILESIZE:
                if($this->_value < 1024){
                    $value = $this->_value.' '.$translate->translate('GENERAL_FS_BYTE'); 
                    break;
                }
                $value = $this->_value/1024;
                if($value < 1000){
                    $value = round($value).' '.$translate->translate('GENERAL_FS_KBYTE'); 
                    break;
                }
                $value = $value/1024;
                if($value < 1000){
                    $value = round($value, 1).' '.$translate->translate('GENERAL_FS_MBYTE'); 
                    break;
                }
                $value = $value/1024; 
                if($value < 1000){
                    $value = round($value, 2).' '.$translate->translate('GENERAL_FS_GBYTE'); 
                    break;
                }
                break;
            case self::STANDARD:
            default: 
                $value = $this->_value; 
                break;
        }
        
        return $value;
    }
}
?>
