<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: External.php 1208 2010-02-27 19:07:04Z ms $
 */
class Sicore_Models_Node_Property_External extends Sicore_Models_Node_Property
                                          implements Sicore_Models_Node_Property_Database_Interface{
    
    /**
     * Mögliche Protokolle
     *
     * @var Array
     */
    protected $_protocols = array('http', 'ftp', 'mailto');
    
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        $this->_value = (string)$value;
        $this->_rootUid = $rootUid;  
        $this->_canPublish = (bool)$canPublish;
        $this->_deleteSubfields = (bool)$deleteSubfields;  
    } 
    
    public function value($cleanHtml = false)
    {
        if(empty($this->_value)) return;
        
        foreach($this->_protocols as $protocol){
            if(substr($this->_value, 0, strlen($protocol)+3) == "$protocol://"){
                return $this->_value;
            }
        }  
         
        return $this->_protocols[0].'://'.$this->_value; 
    }  
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->value();
        return $data;
    }
}
?>
