<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Page.php 1540 2010-09-21 15:51:20Z ms $
 */
class Sicore_Models_Node_Property_Page extends Sicore_Models_Node_Property
                                       implements Sicore_Models_Node_Property_Database_Interface, 
                                                  Sicore_Models_Node_Property_Join_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {        
        $this->_value = $value;
        $this->_rootUid = $rootUid;  
        $this->_canPublish = (bool)$canPublish;   
        $this->_deleteSubfields = (bool)$deleteSubfields; 
    }
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->_value;
        return $data;
    }
    
    public function toArray(){
        if(empty($this->_value)){
            return false;
        }
        if($this->_config->multi){
            return explode(',', $this->_value);
        }else{
            return array($this->_value);
        }
    }
    
    public function getJoinedData($isDraft = true, $language = 'de')
    {
        $data = array();
        
        $mNodes = new Sicore_Models_Server_Db_Nodes();
        $values = explode(',', $this->_value);
        
        foreach($values as $value){
            if(empty($value)) continue;
            
            try{
                $node = $mNodes->get(intval($value), $language, $isDraft);
                $data[$node->uid->value()] = $node->getLabel(true);
            }catch(Sifront_Models_Exception_Pagenotfound $e){}
            
            if(!$this->_config->multi){
                $this->_value = $value;
                break;
            }
        }
        
        
        
        return $data;
    }
    
}
?>
