<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Siurl.php 1479 2010-06-30 15:57:23Z ms $
 */
class Sicore_Models_Node_Property_Siurl extends Sicore_Models_Node_Property
                                         implements Sicore_Models_Node_Property_Database_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        $this->_value = (string)$value;
        $this->_rootUid = $rootUid; 
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields; 
    }
    
    public function toDatabase(Array $data){
        $uid = $this->_nodeUid;
        $value = $this->value();
        
        if($value){
            $mAlias = new Sicore_Models_Server_Db_Urlalias();
            $alias  = $mAlias->check('', $value, $uid, true);
        }else{
            $alias = null;
        }   
        $data[$this->field()] = (string)$alias; 
        return $data;
    }
}
?>
