<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: String.php 1208 2010-02-27 19:07:04Z ms $
 */
class Sicore_Models_Node_Property_String extends Sicore_Models_Node_Property
                                         implements Sicore_Models_Node_Property_Database_Interface{
                                             
    const LINEBREAK = "\r\n";
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false, $seperator = ',')
    {
        if(is_array($value)){
            $this->setFromArray($value, $seperator) ;
        }else{
            $this->_value = (string)$value;
        }
        $this->_rootUid = $rootUid;
        $this->_canPublish = (bool)$canPublish;
        $this->_deleteSubfields = (bool)$deleteSubfields;  
    }
    
    public function toArray($seperator = ',')
    {
        
        if(strpos($this->_value, $seperator) === false){
            $this->_value = nl2br($this->_value);
            $this->_value = str_replace('<br>', '<br/>', $this->_value);  
            $this->_value = str_replace('<br />', '<br/>', $this->_value);
            $this->_value = str_replace("\n", '', $this->_value);
            $this->_value = str_replace("\r", '', $this->_value); 
            $seperator = '<br/>';  
        }

        return explode($seperator, $this->_value);
    }
    
    
    public function setFromArray($value, $seperator = ',')
    {
        if(strpos($value, $seperator) === false){
            $seperator = self::LINEBREAK;
             
        }  
        $this->_value = implode($seperator, $this->_value);
    }
    
    public function toDatabase(Array $data){
        if (get_magic_quotes_gpc()) {
            $this->_value =  stripslashes($this->_value);
        } 
        $data[$this->field()] = (string)$this->_value;
        return $data;
    }
}
?>
