<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Db.php 1365 2010-05-26 10:09:57Z ms $
 */
class Sicore_Models_Server_Db
{
    protected $_con     = null;
    protected $_prefix  = null;
    
    public function __construct(){
        $this->_con = Sicore_Models_Registry::getDbAdapter();
        $this->_con->setFetchMode(Zend_Db::FETCH_OBJ);
        $this->_con->exec('SET NAMES utf8');
    
        $config        = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        $this->_prefix = $config->database->prefix;
    }
    
    public function importFile($file){
        if(!file_exists($file)) return false;
        
        $this->_con->beginTransaction(); 
        
        try{ 
           
            $content = file_get_contents($file);
            $sql     = explode(';', $content);
            
            foreach($sql as $exec) {
                $exec = str_replace("\n", "", $exec);
                $exec = str_replace("\r", "", $exec);
                if (empty($exec)) continue;
                $this->_con->exec($exec);
            }    
            
            $this->_con->commit();
            return true; 
            
        }catch(Exception $e){
            $this->_con->rollback();
            throw new Exception("DB-Import '".$dir."install/data.sql' failed: ".$e->getMessage());
        }    
    }
}
