<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Http.php 1225 2010-03-06 20:11:33Z ms $
 */
class Sicore_Models_Server_Http
{
    protected $_url          = null;
    protected $_maxredirects = null; 
    protected $_timeout      = null;
    
    protected $_inumber      = null;
    protected $_secret       = null;
    
    protected $_client       = null; 
    
    public function __construct($url, $maxredirects = 0, $timeout = 30)
    {
        $this->_url          = $url;
        $this->_maxredirects = intval($maxredirects);
        $this->_timeout      = intval($timeout);
        
        $this->_client = new Zend_Http_Client($this->_url);
        
        $this->_client->setConfig(array(
            'maxredirects' => $this->_maxredirects,
            'timeout'      => $this->_timeout,
            'useragent'    => 'Simploo CMS'
        ));
    }  
    
    public function setCredentials($inumber, $secret)
    {
        $this->_inumber = $inumber;
        $this->_secret  = $secret;        
    }  
}
