<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Updates.php 1267 2010-03-25 08:45:27Z ms $
 */
class Sicore_Models_Server_Http_Updates extends Sicore_Models_Server_Http
{
    public function __construct($url, $maxredirects = 0, $timeout = 30)
    {
        parent::__construct($url, $maxredirects, $timeout);
        $this->_client->setMethod(Zend_Http_Client::POST); 
    }
    
    public function search($relase)
    {
        $uri = substr(Sicore_Models_Helper_FSO::joinPath($this->_url, 'updates/search'), 1);
        
        
        $this->_client->setUri($uri);
        $this->_client->setParameterPost(array(
            'i'       => $this->_inumber,
            'h'       => sha1($this->_inumber.$this->_secret),
            'release' => $relase
        ));
        $response = $this->_client->request();
        if($response->isError()){
            Sicore_Models_Logger::error('Status '.$response->getStatus().': '.$response->getMessage().' (Update-Server: '.$uri.')');
            return false;
        }
        
        return $response->getBody();    
    }
    
    public function get($uid, $save, $mode = 'zip')
    {
        $uri = substr(Sicore_Models_Helper_FSO::joinPath($this->_url, 'updates/get'), 1);
        
        $this->_client->setUri($uri);
        $this->_client->setParameterPost(array(
            'i'    => $this->_inumber,
            'h'    => sha1($this->_inumber.$this->_secret),
            'id'   => $uid, 
            'mode' => $mode 
        ));

        $response = $this->_client->request();
        if($response->isError()){
            Sicore_Models_Logger::error('Status '.$response->getStatus().': '.$response->getMessage().' (Update-Server: '.$uri.')');
            return false;
        }
        if(!$save){
            return $response;
        }
        //$response->getHeadersAsString()
        $path    = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp');
        $tmpname = tempnam($path, 'update');
        file_put_contents($tmpname, $response->getBody());
        return $tmpname;    
    }     
}
