<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Templates.php 1221 2010-03-03 20:46:55Z ms $
 */
class Sicore_Models_Server_Templates
{
    protected $_dir = null;
    
    public function __construct($dir){
        $this->_dir = $dir;    
    }
    
    public function get($folder)
    {
        if(!file_exists($this->_dir.'/'.$folder.'/config.ini.php')) return false;
        
        $config   = new Zend_Config_Ini($this->_dir.'/'.$folder.'/config.ini.php');
        $icon     = null;
        
        $template = new Sicore_Models_Template_Local($folder, 
                                                     $config->name, 
                                                     $config->author,
                                                     $config->description, 
                                                     $icon, 
                                                     $config
                                                    ); 
                                                    
        return $template;     
    }   
    
    public function getAll()
    {
        $data = array();
        
        $iterator = new DirectoryIterator($this->_dir);
        foreach ($iterator as $fileinfo) {
            if($fileinfo->getFilename() == '.' || $fileinfo->getFilename() == '..') continue; 
            if(!is_dir($fileinfo->getPathname())) continue;
            if(!file_exists($fileinfo->getPathname().'/config.ini.php')) continue;
            $config = new Zend_Config_Ini($fileinfo->getPathname().'/config.ini.php');
            $icon   = null;
            
            $data[$fileinfo->getFilename()] = new Sicore_Models_Template_Local($fileinfo->getFilename(), 
                                                                               $config->name, 
                                                                               $config->author,
                                                                               $config->description,
                                                                               $icon, 
                                                                               $config
                                                                              );            
        } 
        
        return $data;       
    } 
      
}
