<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Template.php 1221 2010-03-03 20:46:55Z ms $
 */
abstract class Sicore_Models_Template
{
    protected $_name        = null;
    protected $_folder      = null; 
    protected $_author      = null; 
    protected $_icon        = null;
    protected $_description = null;
    
    public function __construct($folder, $name, $author = null, $description = null, $icon = null)
    {
        $this->_name          = $name;
        $this->_folder        = $folder;
        $this->_author        = $author;  
        $this->_icon          = $icon;
        $this->_description   = $description; 
    } 
    
    public function getFolder()
    {
        return $this->_folder;
    }
    
    public function getName()
    {
        return $this->_name;
    }
    
    public function getAuthor()
    {
        return $this->_author;
    }
    
    public function getDescription()
    {
        return $this->_description;
    }
    
    public function getIcon()
    {
        return $this->_icon;
    }
      
}

