<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Uobj   
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: User.php 1268 2010-03-25 11:06:37Z ms $
 */
class Sicore_Models_Uobj_User extends Sicore_Models_Uobj
{    
         
    /**
     * Konstruktor
     *
     * @param Array $rawData Datenbankfelder des Datensatzes
     */
    public function __construct($rawData = null){
        parent::__construct($rawData); 
        if($this->_config->Sicore_Models_Uobj_User) $this->_loadConfig($this->_config->Sicore_Models_Uobj_User);
        $this->init($rawData);
        $this->isgroup->set(false);  
    } 
    
        
    /**
    * Gibt den kompletten Namen zurück
    *
    * @return String
    */ 
    public function getName()
    {
        return trim($this->firstname->value().' '.$this->lastname->value());
    }
    
    
    /**
    * Generiert eine eindeutige Nummer zum "Sperren" der Tabellen
    *
    * @return String
    */ 
    public function generateFlag()
    {
        return md5($this->uid->value().time());
    }
    
    /**
    * Generiert einen Key
    *
    * @return String
    */ 
    public static function generateSecret()
    {
        return self::_generateKey(8); 
    }
    
    /**
    * Generiert ein zufälliges Passwort
    *
    * @return String
    */ 
    public static function generateRandomPass()
    {
        return self::_generateKey(6);
    }
    
    protected static function _generateKey($length)   
    {
        $pool = "qwertzupasdfghkyxcvbnm";
        $pool .= "23456789";
        $pool .= "WERTZUPLKJHGFDSAYXCVBNM";
        srand ((double)microtime()*1000000);
        
        $key = '';
        
        for($index = 0; $index < $length; $index++)
        {
            $key .= substr($pool,(rand()%(strlen ($pool))), 1);
        }
        
        return $key;
    }

      
}

