<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist f?r Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * ben?tigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden F?llen m?ssen Sie ?ber www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: ContentController.php 1538 2010-09-11 08:33:56Z ms $
 */
class ContentController extends Sifront_Controllers_Simploo  
{
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('insertelement',  'json');  
        parent::init();
    }
    
    public function getAction()
    {
        $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        
        if($this->getRequest()->getParam('action') == 'get'){
            $this->_redirect("/".$config_base->website->path);
        }
        
        if($this->view->content){
            $this->dispatch('showAction'); 
        }else{
            $this->dispatch('listAction');   
        }
    }
    
    public function showAction()
    {
        if(($nid = $this->getRequest()->getParam('nid'))){
            //$node = 
        }
        $this->_helper->viewRenderer('content/single');  
    }
    
    public function listAction()
    {
        
        $this->_helper->viewRenderer('content/list'); 
    }
    
    public function insertelementAction()
    {
        $ident = Zend_Auth::getInstance()->getIdentity();
        
        $pageUid      = intval($this->getRequest()->getParam('page')); 
        $contentUid   = intval($this->getRequest()->getParam('content'));
        
        $position     = $this->getRequest()->getParam('position', 'after');
        $type         = $this->getRequest()->getParam('type');
        $config       = $this->getRequest()->getParam('config');  
        $lang         = $this->getRequest()->getParam('lang');
        
        $data = array();
        
        try{        
            $mNodes = new Sicore_Models_Server_Db_Nodes();
            
            if($contentUid){
                $node = $mNodes->get($contentUid, $lang, true);
            }else{
                $node = null;     
            }
            $page = $mNodes->get($pageUid, $lang, true);
            
            if(($template = $page->template->value())){ 
                $this->view->addScriptPath("templates/frontend/$template");
            }
            
            if($config){
                $content = new $type(null, $config);   
            }else{
                $content = new $type();
            }
            
            $contentObject = $mNodes->createContent($content, $page, $ident->generateFlag(), $node, $position, $lang);
            
            $this->view->newElement = true;
            $this->view->content    = $contentObject;
            $data['content']        = $this->view->render('content/new.phtml'); 
            $data['uid']            = $contentObject->uid->value();
            
            if($this->getRequest()->getparam('getversions')){
                //$mVersions = new Sicore_Models_Server_Db_Version();
                //$this->view->versions = $mVersions->getByPage($pageUid);
                $data['versions']     = count($this->view->versions) ? $this->view->render('menu/versions.phtml') : ''; 
            }
            
        }catch(Exception $e){
            $data['content'] = null;
            $data['error']   = $e->__toString();
            Sicore_Models_Logger::exception($e);
        }
        echo Zend_Json::encode($data);
        die();  
    }
    
}