<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui_Form
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Form.php 1294 2010-03-31 17:48:59Z ms $
 */

class Sifront_Models_Form extends Zend_Form
{
    protected $_feuser    = null;  
    protected $_page      = null; 
    protected $_path      = null;
    protected $_pathAbs   = null;
    protected $_translate = null; 
    
    public function __construct() 
    {
        $this->_feuser    = Sicore_Models_Registry::getUser();
        $this->_page      = Sicore_Models_Registry::getPage();  
        $config           = Sicore_Models_Registry::getConfig();
        $this->_path      = Sicore_Models_Helper_FSO::joinPath($config->website->path);
        $this->_pathAbs   = Sicore_Models_Helper_FSO::joinPathAbs($config->website->path);  
        $this->_translate = Sicore_Models_Registry::getTranslate(); 
        parent::__construct();
        
        $this->addElementPrefixPath('Simploo_Filter', 'Simploo/Filter', 'filter');
        
        if($this->_page instanceof Sicore_Models_Node_Page){        
            $element = new Zend_Form_Element_Hidden('uid');
            $element->setValue($this->_page->uid->value());
            $element->removeDecorator('Label');  
            $this->addElement($element);
            
            $element = new Zend_Form_Element_Hidden('lang');
            $element->setValue($this->_page->language->value());
            $element->removeDecorator('Label');
            $this->addElement($element);  
        }
    } 
}