<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui_Form
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Login.php 1499 2010-08-02 10:14:27Z ms $
 */

class Sifront_Models_Form_Login extends Sifront_Models_Form
{
    protected $_data = array();
    
    public function __construct($data = array())
    {
        $this->_data = $data;
        parent::__construct();
    }
    
    public function init()
    {
        $this->setAttrib('id', 'si_loginform'); 
        $this->setAttrib('class', 'si_quickform');  
        $element = new Zend_Form_Element_Text('si_username');
        $element->setLabel('GENERAL_USERNAME');
        $element->setRequired(true);
        $element->setAttrib('autocomplete', 'off');
        $element->addValidator(new Zend_Validate_Db_RecordExists('si_users', 'alias'));  
        $this->addElement($element);
        
        $element = new Zend_Form_Element_Password('si_password');
        $element->setLabel('GENERAL_PASSWORD');
        $element->setRequired(true); 
        $element->setAttrib('autocomplete', 'off'); 
        $element->addValidator(new Simploo_Validate_Db_PasswordExists('si_users', 'pass', array('field' => 'alias', 'value' => $this->_data['si_username']))); 
        $this->addElement($element);
        
        $element = new Zend_Form_Element_Button('si_login');
        $element->setLabel('GENERAL_LOGIN');
        $element->setAttrib('type', 'submit');
        $this->addElement($element);
    }   
}