<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui_Form
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Register.php 1368 2010-06-01 09:36:05Z ms $
 */

class Sifront_Models_Form_Register extends Sifront_Models_Form
{
    protected $_data   = array();
    protected $_config = null;
    
    public function __construct($config, $data = array())
    {
        $this->_data   = $data;
        $this->_config = $config;
        parent::__construct();
    }
    
    public function init()
    {
        $config_base     = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        $config_frontend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        if($this->_config->feform->class) $this->setAttrib('class', $this->_config->feform->class);  
        $layout = str_replace(' ', '', $this->_config->feform->layout);
        $layout = explode(',', $layout);
        
        foreach($layout as $key){
            if(!($this->_config->properties->$key instanceof Zend_Config)) continue;
            if($this->_config->properties->$key->feform instanceof Zend_Config){
                $config  = $this->_config->properties->$key->feform;  
            }elseif($this->_config->properties->$key->form instanceof Zend_Config){
                $config  = $this->_config->properties->$key->form;  
            }else{
                continue;
            }   
            $element = new $config->type($key);
            if($config->options instanceof Zend_Config) $element->setConfig($config->options);
             
            $this->addElement($element, $key);
        }
        $element = new Zend_Form_Element_Hidden('registerformSended');
        $element->setValue("1");
        $this->addElement($element, 'registerformSended');  
        
    }   
}