<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Content.php 1540 2010-09-21 15:51:20Z ms $
 */
class Sifront_Views_Helpers_Content extends Zend_View_Helper_Abstract
{
    
    protected $_jquery = null;
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;       
    }
    
    public function content($container_id = 'default')
    { 
        $request = Zend_Controller_Front::getInstance()->getRequest();  
        $post    = $request->getPost();
        
        if($request->getParam('loginform') == 'register'){
            return $this->view->registerform();
        }
        
        if(isset($post['si_sword'])){ 
            return $this->view->searchresult();
        }

        if(!$this->view->isDraft && !$this->view->page->nocache->value()){
            $cache = Sicore_Models_Registry::getCache();
            if($this->view->content instanceof Sicore_Models_Node_Content){
                $key = 'contenthtml_'.$this->view->content->uid->value();  
                if(!$data = $cache->load($key)){
                    $data = $this->view->render('content/single.phtml');
                    $cache->save($data, $key, array('content', (string)$this->view->page->uid->value(), (string)$this->view->content->uid->value()));       
                }
                return $data;
            }else{
                if($this->view->page->pagesize->value()){
                    $p   = intval($request->getParam('p'));
                    $key = 'contenthtml_'.$this->view->page->uid->value().'_'.$p; 
                }else{
                    $key = 'contenthtml_'.$this->view->page->uid->value(); 
                }
                if(!$data = $cache->load($key)){ 
                    $data = $this->view->render('content/list.phtml');
                    $cache->save($data, $key, array('content', (string)$this->view->page->uid->value()));      
                }
                return $data;       
            }
        }else{        
            if($this->view->content instanceof Sicore_Models_Node_Content){
                return $this->view->render('content/single.phtml');   
            }else{
                return $this->view->render('content/list.phtml');
            } 
        }
    }
     

}
?>
