<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Link.php 1447 2010-06-23 09:41:55Z ms $
 */
class Sifront_Views_Helpers_Link extends Zend_View_Helper_Abstract
{
    protected $_params = array();
    protected $_args   = array(); 
        
    public function addParam($key, $value)
    {
        if(!empty($value)){
            $this->_params[(string)$key] = $value;
        }
        return $this;
    }
    
    public function setParams($params)
    {
        $this->_params = $params;
        return $this;  
    }
    
    public function resetParams()
    {
        $this->_params = array();
        return $this;  
    }
    
    public function link()
    {
        $this->resetParams();
        $this->_args = func_get_args();
        return $this;
    }
    
    public function __toString()
    {
        $link = '';
        
        $currentPage = Sicore_Models_Registry::getPage();
        
        $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        $mLink = new Sicore_Models_Helper_Link($config_base->website->path);
        $mLink->setParams($this->_params);
        
        if(!isset($this->_params['draft']) && ($ver = intval($this->view->request->getParam('draft')))){
            $mLink->setDraft((bool)$ver);
        }                 
        if(isset($this->_params['draft'])){
            $mLink->setDraft((bool)$this->_params['draft']);
        } 
        if(($lang = $this->view->request->getParam('lang'))){
            $mLink->setLanguage($lang);
        }
         
        switch(count($this->_args)){
            case 1:
                if($this->_args[0] instanceof Sicore_Models_Node){
                    $link = $mLink->getByNode($this->_args[0]);
                }elseif(is_integer($this->_args[0])){
                    $mNodes = new Sicore_Models_Server_Db_Nodes();
                    try{ 
                        $node = $mNodes->get($this->_args[0], $lang ? $lang : $currentPage->getLanguage() );
                        $link = $mLink->getByNode($node); 
                    }catch(Sifront_Models_Exception_Pagenotfound $e){
                        $link = $mLink->getByuid($this->_args[0]); 
                    }
                }
                break;
            case 3:
                $link = $mLink->get($this->_args[0], $this->_args[1], $this->_args[2]);
                break; 
            default:    
                $link = $mLink->getHome();  
                break;  
        }
        
        return $link;
    }
     
   
}
?>
