<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Searchresult.php 1304 2010-04-20 14:49:12Z ms $
 */
class Sifront_Views_Helpers_Searchresult extends Zend_View_Helper_Abstract
{
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;     
    }
    
    public function searchresult($template = 'result.phtml')
    {
        $config_frontend     = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $request = Zend_Controller_Front::getInstance()->getRequest(); 
        $sWord   = $request->getParam('si_sword');
        $filter  = new Simploo_Filter_Sistrip();
        $sWord   = $filter->filter($sWord);
        
        if(strlen($sWord) >= intval($config_frontend->search->sword->minlen)){
            $mNodes             = new Sicore_Models_Server_Db_Nodes();
            $this->view->data   = $mNodes->search($sWord);
            $this->view->sWord  = $sWord;
        }else{
            $this->view->err_minlen = intval($config_frontend->search->sword->minlen);
        }
        
        return $this->view->render('search/'.$template); 
    } 
}
?>
