<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist f?r Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * ben?tigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden F?llen m?ssen Sie ?ber www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo_Start
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: bootstrap.php 1559 2010-10-22 14:05:24Z ms $
 */

//Workaround for Flash-Uploader
 if (isset($_POST['PHPSESSID']))
{
     $_SERVER['HTTP_X_REQUESTED_WITH'] = "XMLHttpRequest";
        
     Zend_Session::setId($_POST['PHPSESSID']);
}

 

//System-Konfiguration laden
$config_base        = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/base.ini.php',       APPLICATION_PATH . '/config/custom/base.ini.php',    null, null, array('allowModifications' => true));
$config_frontend    = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/frontend.ini.php',   APPLICATION_PATH . '/config/custom/frontend.ini.php',    null, null, array('allowModifications' => true));
$config_backend     = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/backend.ini.php',    APPLICATION_PATH . '/config/custom/backend.ini.php',    null, null, array('allowModifications' => true));
$config_nodes       = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/nodes.ini.php',      APPLICATION_PATH . '/config/custom/nodes.ini.php',   null,  null, array('allowModifications' => true));
$config_filesystem  = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/filesystem.ini.php', APPLICATION_PATH . '/config/custom/filesystem.ini.php',    null, null, array('allowModifications' => true));
$config_content     = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/content.ini.php',    APPLICATION_PATH . '/config/custom/content.ini.php',    null, null, array('allowModifications' => true));
$config_users       = new Simploo_Config_Ini(APPLICATION_PATH . '/config/system/users.ini.php',      APPLICATION_PATH . '/config/custom/users.ini.php',    null, null, array('allowModifications' => true));

foreach($config_base->general->modules as $module){
    $autoloader->registerNamespace($module.'_');
    if(file_exists(APPLICATION_PATH.'/application/'.$module.'/Config/content.ini.php')){
        $config = new Simploo_Config_Ini(APPLICATION_PATH.'/application/'.$module.'/Config/content.ini.php');
        $config_content->merge($config);
    }
    if(file_exists(APPLICATION_PATH.'/application/'.$module.'/Config/nodes.ini.php')){
        $config = new Simploo_Config_Ini(APPLICATION_PATH.'/application/'.$module.'/Config/nodes.ini.php');
        $config_nodes->merge($config);
    }   
} 

$config = array(Sicore_Models_Registry::CONFIG_BASE        => $config_base,
                Sicore_Models_Registry::CONFIG_FRONTEND    => $config_frontend, 
                Sicore_Models_Registry::CONFIG_BACKEND     => $config_backend,
                Sicore_Models_Registry::CONFIG_NODES       => $config_nodes,
                Sicore_Models_Registry::CONFIG_FILESYSTEM  => $config_filesystem ,
                Sicore_Models_Registry::CONFIG_CONTENT     => $config_content,
                Sicore_Models_Registry::CONFIG_USERS       => $config_users 
               ); 

//Cache
$lifetime = intval($config_frontend->cache->lifetime);

$frontendOptions = array(
   'lifetime' => $lifetime > -1 ? $lifetime : null,
   'automatic_serialization' => true,
   'caching' => (bool)$config_frontend->cache->enable
);

$backendOptions = array(
    'cache_dir' => APPLICATION_PATH.'/data/cache/'
);

// Ein Zend_Cache_Core Objekt erzeugen
$cache = Zend_Cache::factory('Core',
                             'File',
                             $frontendOptions,
                             $backendOptions);
Sicore_Models_Registry::setCache($cache);
             
//Session Management
$authNamespache = new Zend_Session_Namespace('Simploo_Auth');
$auth = Zend_Auth::getInstance();
$auth->setStorage(new Zend_Auth_Storage_Session('Simploo_Auth'));
if (!isset($authNamespache->initialized)) {
    Zend_Session::regenerateId();
    $authNamespache->initialized = true;
} 

if(Zend_Auth::getInstance()->hasIdentity() && $authNamespache->key != md5($config_base->app->number.$config_base->customer->secret)){
    Zend_Auth::getInstance()->clearIdentity();
    Zend_Session::regenerateId();    
}
      
//Bildbearbeitung initialisieren
Sicore_Models_Image::init($config_base);
               
//DB-Adapter laden
try{
    $db = Zend_Db::factory($config_base->database);
    $db->query("SET NAMES 'utf8'");
}catch(Exception $e){
    //die('Keine Vebrindung zur Datenbank m?glich.');
}
 
//Registry erstellen 
new Sicore_Models_Registry($config, $db, new Zend_Acl());       
Zend_Db_Table::setDefaultAdapter($db);
//Translation
Zend_Locale::setDefault('de');
$locale = new Zend_Locale('de'); 
Sicore_Models_Registry::setLocale($locale);

if (file_exists(APPLICATION_PATH.'/languages/system/de.php')) {
    ob_start();
    $data = include(APPLICATION_PATH.'/languages/system/de.php');
    ob_end_clean();
}
if (file_exists(APPLICATION_PATH . '/languages/custom/de.php')) {
    ob_start();
    $data_cust = include(APPLICATION_PATH . '/languages/custom/de.php');
    ob_end_clean();
    $data = array_merge($data, $data_cust);
}
foreach($config_base->general->modules as $modules){
    if(file_exists(APPLICATION_PATH.'/application/'.$module.'/Languages/de.php')){ 
        ob_start();
        $data_cust = include(APPLICATION_PATH.'/application/'.$module.'/Languages/de.php');
        ob_end_clean();
        $data = array_merge($data, $data_cust);    
    }
}

$translate = new Zend_Translate('array', $data, 'de');
Sicore_Models_Registry::setTranslate($translate); 
//Logging
$writer = new Zend_Log_Writer_Stream(APPLICATION_PATH.'/data/logs/info.txt');
Sicore_Models_Registry::setLogger(new Zend_Log($writer), 'info');
$writer = new Zend_Log_Writer_Stream(APPLICATION_PATH.'/data/logs/error.txt');
Sicore_Models_Registry::setLogger(new Zend_Log($writer), 'error'); 
$writer = new Zend_Log_Writer_Stream(APPLICATION_PATH.'/data/logs/exception.txt');
Sicore_Models_Registry::setLogger(new Zend_Log($writer), 'exception'); 

if($config_filesystem->options->resetumask) umask(0);

//Mail
if($config_base->mail->smtp->server){
    if($config_base->mail->smtp-user){
        $mailconfig = array('auth'     => 'login',
                            'username' => $config_base->mail->smtp->user,
                            'password' => $config_base->mail->smtp->pass
                            );
    }else{
        $mailconfig = array();
    }
    
    $tr = new Zend_Mail_Transport_Smtp($config_base->mail->smtp->server, $mailconfig);
    Zend_Mail::setDefaultTransport($tr);
}

//Front-Controller initialisieren
Zend_Controller_Front::getInstance()
    ->setParam('root', APPLICATION_PATH) 
    ->setModuleControllerDirectoryName('Controllers')
    ->addModuleDirectory(APPLICATION_PATH . '/application')
    ->setDefaultModule('Sifront')
    ->throwExceptions(false)
    ->setParam('noErrorHandler', false) 
    ->setDefaultControllerName('page') 
    ->registerPlugin(new Sifront_Controllers_Plugins_Seo())  
    ->registerPlugin(new Sicore_Controllers_Plugins_Auth()); 

