SET FOREIGN_KEY_CHECKS=0;

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

SET AUTOCOMMIT=0;
START TRANSACTION;

DROP TABLE IF EXISTS `si_files`;
CREATE TABLE `si_files` (
  `uid` int(11) NOT NULL auto_increment,
  `folders_uid` int(11) NOT NULL,
  `class` varchar(100) collate utf8_unicode_ci NOT NULL,
  `name` varchar(50) collate utf8_unicode_ci NOT NULL,
  `title` varchar(50) collate utf8_unicode_ci default NULL,
  `description` varchar(255) collate utf8_unicode_ci default NULL,
  `keywords` varchar(255) collate utf8_unicode_ci default NULL,
  `type` varchar(100) collate utf8_unicode_ci NOT NULL,
  `size` int(11) NOT NULL,
  `uploaded` datetime NOT NULL,
  `changed` datetime NOT NULL,
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `folders_uid_2` (`folders_uid`,`name`),
  KEY `folders_uid` (`folders_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=7 ;

DROP TABLE IF EXISTS `si_folders`;
CREATE TABLE `si_folders` (
  `uid` int(11) NOT NULL auto_increment,
  `uid_parent` int(11) default NULL,
  `level` int(2) NOT NULL,
  `name` varchar(100) character set utf8 collate utf8_bin NOT NULL,
  PRIMARY KEY  (`uid`),
  KEY `uid_parent` (`uid_parent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=6 ;

INSERT INTO `si_folders` (`uid`, `uid_parent`, `level`, `name`) VALUES (1, NULL, 0, 0x53696d706c6f6f20434d53);

DROP TABLE IF EXISTS `si_folders_folders`;
CREATE TABLE `si_folders_folders` (
  `folders_uid_parent` int(11) NOT NULL,
  `folders_uid_child` int(11) NOT NULL,
  PRIMARY KEY  (`folders_uid_parent`,`folders_uid_child`),
  KEY `folders_uid_child` (`folders_uid_child`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `si_folders_users`;
CREATE TABLE `si_folders_users` (
  `uid` int(11) NOT NULL,
  `user_uid` int(11) NOT NULL,
  `folders_uid` int(11) NOT NULL,
  `read` tinyint(1) NOT NULL,
  `write` tinyint(1) NOT NULL,
  PRIMARY KEY  (`uid`),
  KEY `user_uid` (`user_uid`),
  KEY `folders_uid` (`folders_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

DROP TABLE IF EXISTS `si_language`;
CREATE TABLE `si_language` (
  `code` varchar(2) collate utf8_unicode_ci NOT NULL,
  `name` varchar(100) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `si_language` (`code`, `name`) VALUES ('de', 'Deutsch');

DROP TABLE IF EXISTS `si_nodes`;
CREATE TABLE `si_nodes` (
  `uid` int(11) NOT NULL,
  `version` tinyint(4) NOT NULL default '0',
  `version_status` enum('EDITED','ADDED','DELETED') collate utf8_unicode_ci default NULL,
  `language_code` varchar(2) collate utf8_unicode_ci NOT NULL default 'de',
  `tags` varchar(255) collate utf8_unicode_ci default NULL,
  `template` varchar(50) collate utf8_unicode_ci default NULL,
  `permalink` varchar(200) collate utf8_unicode_ci default NULL,
  `added` datetime default NULL,
  `changed` datetime default NULL,
  `isactive` tinyint(1) default '1',
  `ishidden` tinyint(1) default '0',
  `startdate` datetime default NULL,
  `enddate` datetime default NULL,
  `redirect` int(11) unsigned default NULL,
  `autoredirect` tinyint(1) default NULL,
  `nosearch` tinyint(1) NOT NULL default '0',
  `nocache` tinyint( 1 ) NULL DEFAULT '0',
  `access` varchar(50) collate utf8_unicode_ci default NULL,
  `class` varchar(100) collate utf8_unicode_ci NOT NULL,
  `meta` mediumtext collate utf8_unicode_ci,
  `pagesize` int(3) NOT NULL default '0',
  `string1` varchar(255) collate utf8_unicode_ci default NULL,
  `string2` varchar(255) collate utf8_unicode_ci default NULL,
  `string3` varchar(255) collate utf8_unicode_ci default NULL,
  `string4` varchar(255) collate utf8_unicode_ci default NULL,
  `text1` mediumtext collate utf8_unicode_ci,
  `text2` mediumtext collate utf8_unicode_ci,
  `text3` mediumtext collate utf8_unicode_ci,
  `text4` mediumtext collate utf8_unicode_ci,
  `integer1` int(11) unsigned default NULL,
  `integer2` int(11) unsigned default NULL,
  `integer3` int(11) unsigned default NULL,
  `integer4` int(11) unsigned default NULL,
  `decimal1` decimal(10,2) default NULL,
  `decimal2` decimal(10,2) default NULL,
  `decimal3` decimal(10,2) default NULL,
  `decimal4` decimal(10,2) default NULL,
  `bool1` tinyint(1) default NULL,
  `bool2` tinyint(1) default NULL,
  `bool3` tinyint(1) default NULL,
  `bool4` tinyint(1) default NULL,
  `datetime1` datetime default NULL,
  `datetime2` datetime default NULL,
  `datetime3` datetime default NULL,
  `datetime4` datetime default NULL,
  `contentelements` text collate utf8_unicode_ci,
  `caneditpage` varchar(100) collate utf8_unicode_ci default NULL,
  `caneditcontent` varchar(100) collate utf8_unicode_ci default NULL,
  `canpublish` mediumtext collate utf8_unicode_ci,
  `canundo` mediumtext collate utf8_unicode_ci,
  `candelete` varchar(100) collate utf8_unicode_ci default NULL,
  `canaddsubpages` varchar(100) collate utf8_unicode_ci default NULL,
  `caneditsubpages` varchar(100) collate utf8_unicode_ci default NULL,
  `caneditsubcontent` varchar(100) collate utf8_unicode_ci default NULL,
  `canpublishsubpages` varchar(100) collate utf8_unicode_ci default NULL,
  `canundosubpages` varchar(100) collate utf8_unicode_ci default NULL,
  `candeletesubpages` varchar(100) collate utf8_unicode_ci default NULL,
  `publishfield` varchar(200) collate utf8_unicode_ci default NULL,
  `publishdeletesubfields` text collate utf8_unicode_ci,
  `temp_flag` varchar(50) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`uid`,`version`,`language_code`),
  KEY `version_uid` (`version`),
  KEY `language_code` (`language_code`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO `si_nodes` (`uid`, `version`, `version_status`, `language_code`, `tags`, `template`, `permalink`, `added`, `changed`, `isactive`, `ishidden`, `startdate`, `enddate`, `redirect`, `autoredirect`, `nosearch`, `access`, `class`, `meta`, `pagesize`, `string1`, `string2`, `string3`, `string4`, `text1`, `text2`, `text3`, `text4`, `integer1`, `integer2`, `integer3`, `integer4`, `decimal1`, `decimal2`, `decimal3`, `decimal4`, `bool1`, `bool2`, `bool3`, `bool4`, `datetime1`, `datetime2`, `datetime3`, `datetime4`, `contentelements`, `caneditpage`, `caneditcontent`, `canpublish`, `canundo`, `candelete`, `canaddsubpages`, `caneditsubpages`, `caneditsubcontent`, `canpublishsubpages`, `canundosubpages`, `candeletesubpages`, `publishfield`, `publishdeletesubfields`, `temp_flag`) VALUES (1, 0, NULL, 'de', 'footer', '', '', NULL, '2010-06-12 10:13:47', 1, 0, NULL, NULL, 0, 0, 0, '', 'Sicore_Models_Node_Page', '', 0, 'Startseite', '', '', '', '', '', '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Sicore_Models_Node_Content_Text,Sicore_Models_Node_Content_Infoblock,news,gallery,Sicore_Models_Node_Content_Contactform', '', '', '', '', '', '', '', '', '', '', '', NULL, NULL, NULL);

DROP TABLE IF EXISTS `si_settings`;
CREATE TABLE `si_settings` (
  `uid` varchar(20) NOT NULL,
  `sorting` int(2) NOT NULL,
  `action` varchar(50) default NULL,
  `controller` varchar(50) default NULL,
  `module` varchar(50) default NULL,
  PRIMARY KEY  (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('bemodules', 40, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('contentelements', 40, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('general', 10, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('general_data', 10, 'generaldata', 'settings', '');
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('general_licence', 20, 'generallicence', 'settings', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('general_system', 30, 'generalsystem', 'settings', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('logging', 30, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('logging_options', 20, 'loggingoptions', 'settings', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('logging_show', 10, 'loggingshow', 'settings', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('updates', 20, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('updates_onlinepool', 30, 'onlinepool', 'updates', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('updates_options', 20, 'options', 'updates', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('updates_search', 10, 'search', 'updates', NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('backup', 25, NULL, NULL, NULL);
INSERT INTO `si_settings` (`uid`, `sorting`, `action`, `controller`, `module`) VALUES ('backup_database', 10, 'dblist', 'backup', NULL);

DROP TABLE IF EXISTS `si_tree`;
CREATE TABLE `si_tree` (
  `uid` int(11) NOT NULL auto_increment,
  `uid_parent` int(11) default NULL,
  `ispage` tinyint(1) default '1',
  `sorting` int(11) NOT NULL,
  `level` tinyint(3) NOT NULL,
  `temp_uid` int(11) default NULL,
  `temp_uid_parent` int(11) default NULL,
  `temp_flag` varchar(50) collate utf8_unicode_ci default NULL,
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `uid_parent` (`uid_parent`,`ispage`,`sorting`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=132 ;

INSERT INTO `si_tree` (`uid`, `uid_parent`, `ispage`, `sorting`, `level`, `temp_uid`, `temp_uid_parent`, `temp_flag`) VALUES (1, NULL, 1, 1, 0, NULL, NULL, NULL);

DROP TABLE IF EXISTS `si_tree_tree`;
CREATE TABLE `si_tree_tree` (
  `tree_uid_parent` int(11) NOT NULL,
  `tree_uid_child` int(11) NOT NULL,
  PRIMARY KEY  (`tree_uid_parent`,`tree_uid_child`),
  KEY `tree_uid_child` (`tree_uid_child`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

DROP TABLE IF EXISTS `si_urlalias`;
CREATE TABLE `si_urlalias` (
  `uid` int(11) NOT NULL auto_increment,
  `alias` varchar(255) collate utf8_unicode_ci NOT NULL,
  `nodes_uid` int(11) NOT NULL,
  `language_code` varchar(2) collate utf8_unicode_ci NOT NULL default 'de',
  `version` tinyint(1) NOT NULL default '0',
  `lastvisit` datetime default NULL,
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `alias` (`alias`,`version`,`language_code`),
  UNIQUE KEY `alias2` (`alias`,`nodes_uid`),  
  KEY `version_uid` (`version`),
  KEY `si_urlalias_ibfk_4` (`language_code`),
  KEY `nodes_uid` (`nodes_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=145 ;

DROP TABLE IF EXISTS `si_users`;
CREATE TABLE `si_users` (
  `uid` int(11) NOT NULL auto_increment,
  `uid_parent` int(11) default '0',
  `level` tinyint(3) unsigned NOT NULL default '0',
  `alias` varchar(50) collate utf8_unicode_ci NOT NULL,
  `pass` varchar(40) collate utf8_unicode_ci default NULL,
  `email` varchar(100) collate utf8_unicode_ci default NULL,
  `firstname` varchar(100) collate utf8_unicode_ci default NULL,
  `lastname` varchar(100) collate utf8_unicode_ci default NULL,
  `isactive` tinyint(1) default '1',
  `isgroup` tinyint(1) NOT NULL default '0',
  `gui_showpanel` tinyint(1) NOT NULL default '0',
  `gui_menu_enabled` text collate utf8_unicode_ci,
  `gui_menu_readonly` text collate utf8_unicode_ci,
  `gui_shortcuts` text collate utf8_unicode_ci,
  `isadmin` tinyint(1) default '0',
  PRIMARY KEY  (`uid`),
  UNIQUE KEY `alias` (`alias`),
  KEY `uid_parent` (`uid_parent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=5 ;

INSERT INTO `si_users` (`uid`, `uid_parent`, `level`, `alias`, `pass`, `email`, `firstname`, `lastname`, `isactive`, `isgroup`, `gui_showpanel`, `gui_menu_enabled`, `gui_menu_readonly`, `gui_shortcuts`, `isadmin`) VALUES (1, NULL, 0, 'Simploo CMS', NULL, NULL, NULL, NULL, 1, 1, 0, '', '', NULL, 0);
INSERT INTO `si_users` (`uid`, `uid_parent`, `level`, `alias`, `pass`, `email`, `firstname`, `lastname`, `isactive`, `isgroup`, `gui_showpanel`, `gui_menu_enabled`, `gui_menu_readonly`, `gui_shortcuts`, `isadmin`) VALUES (2, NULL, 0, 'admin', 'd033e22ae348aeb5660fc2140aec35850c4da997', '', '', '', 1, 0, 0, '', '', NULL, 1);

DROP TABLE IF EXISTS `si_users_users`;
CREATE TABLE `si_users_users` (
  `users_uid_parent` int(11) NOT NULL default '0',
  `users_uid_child` int(11) NOT NULL,
  PRIMARY KEY  (`users_uid_parent`,`users_uid_child`),
  KEY `users_uid_child` (`users_uid_child`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

ALTER TABLE `si_files`
  ADD CONSTRAINT `si_files_ibfk_1` FOREIGN KEY (`folders_uid`) REFERENCES `si_folders` (`uid`) ON DELETE CASCADE;

ALTER TABLE `si_folders`
  ADD CONSTRAINT `si_folders_ibfk_1` FOREIGN KEY (`uid_parent`) REFERENCES `si_folders` (`uid`) ON DELETE CASCADE;
 
ALTER TABLE `si_folders_folders`
  ADD CONSTRAINT `si_folders_folders_ibfk_1` FOREIGN KEY (`folders_uid_parent`) REFERENCES `si_folders` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_folders_folders_ibfk_2` FOREIGN KEY (`folders_uid_child`) REFERENCES `si_folders` (`uid`) ON DELETE CASCADE;

ALTER TABLE `si_folders_users`
  ADD CONSTRAINT `si_folders_users_ibfk_1` FOREIGN KEY (`user_uid`) REFERENCES `si_users` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_folders_users_ibfk_2` FOREIGN KEY (`folders_uid`) REFERENCES `si_folders` (`uid`) ON DELETE CASCADE;

ALTER TABLE `si_nodes`
  ADD CONSTRAINT `si_nodes_ibfk_2` FOREIGN KEY (`uid`) REFERENCES `si_tree` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_nodes_ibfk_3` FOREIGN KEY (`language_code`) REFERENCES `si_language` (`code`) ON DELETE CASCADE;

ALTER TABLE `si_tree_tree`
  ADD CONSTRAINT `si_tree_tree_ibfk_1` FOREIGN KEY (`tree_uid_parent`) REFERENCES `si_tree` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_tree_tree_ibfk_2` FOREIGN KEY (`tree_uid_child`) REFERENCES `si_tree` (`uid`) ON DELETE CASCADE;

ALTER TABLE `si_urlalias`
  ADD CONSTRAINT `si_urlalias_ibfk_2` FOREIGN KEY (`nodes_uid`) REFERENCES `si_tree` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_urlalias_ibfk_3` FOREIGN KEY (`language_code`) REFERENCES `si_language` (`code`) ON DELETE CASCADE;

ALTER TABLE `si_users`
  ADD CONSTRAINT `si_users_ibfk_1` FOREIGN KEY (`uid_parent`) REFERENCES `si_users` (`uid`) ON DELETE CASCADE;

ALTER TABLE `si_users_users`
  ADD CONSTRAINT `si_users_users_ibfk_1` FOREIGN KEY (`users_uid_parent`) REFERENCES `si_users` (`uid`) ON DELETE CASCADE,
  ADD CONSTRAINT `si_users_users_ibfk_2` FOREIGN KEY (`users_uid_child`) REFERENCES `si_users` (`uid`) ON DELETE CASCADE;

SET FOREIGN_KEY_CHECKS=1;

COMMIT;
