<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo_Lib
 * @package    JQuery_Views
 * @subpackage Helper
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Drop.php 1545 2010-09-23 08:41:52Z ms $
 */
require_once "ZendX/JQuery/View/Helper/UiWidget.php";

/**
 * jQuery Color Picker View Helper
 *
 * @uses 	   Zend_View_Helper_FormText
 * @package    ZendX_JQuery
 * @subpackage View
 * @copyright  Copyright (c) 2005-2008 Zend Technologies USA Inc. (http://www.zend.com)
 * @license    http://framework.zend.com/license/new-bsd     New BSD License
 */
class Simploo_JQuery_View_Helper_Drop extends ZendX_JQuery_View_Helper_UiWidget
{
	const IDPREFIX = 'siform_'; 
    
    /**
	 * Render a Color Picker in an FormText field.
	 *
	 * @param  string $id
	 * @param  string $value
	 * @param  array  $params
	 * @param  array  $attribs
	 * @return string
	 */
    public function drop($id, $value='', array $attribs=array(), array $options=array())
    {

        $attribs = $this->_prepareAttributes($id, $value, $attribs);
        //$attribs['id'] = self::IDPREFIX$attribs['id'];
        $js = sprintf('%s("#%s_show").bind("click", function(){
                            if(this.selectedIndex >= 0){
                              $(\'.'.self::IDPREFIX.$id.'_show_onlysel\').removeAttr(\'disabled\');
                            }else{
                              $(\'.'.self::IDPREFIX.$id.'_show_onlysel\').addAttr(\'disabled\', \'disabled\');
                            } 
                       });
                       %s("#%s_show").bind("dblclick", function(){ });
                       %s("#%s_show").keydown(function(event){ });
                       %s("#%s_show").mouseout(function(){
                            var hidden_values = new Array();
                            %s("#%s_show option").each(function () {
                                hidden_values.push($(this).val()); 
                            });   
                            %s("#%s").val(hidden_values.join(\',\'));
                            return false;
                          });   
                       ',   
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id'],
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id'],
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id'],
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id'],
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id'],
            ZendX_JQuery_View_Helper_JQuery::getJQueryHandler(),
            $attribs['id']
        );
        
        $this->jquery->addOnLoad($js);
        
        $config_backend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BACKEND);
        
        $dropzones = explode(',', $attribs['dropzone']);
        
        if(isset($config_backend->chooser->$dropzones[0])){
            $mode = $config_backend->chooser->$dropzones[0];
        }else{
            return '';
        }
        
        if(!empty($attribs['multi'])){
            $attribs['class'] =  "si_drop si_multidrop ".str_replace(',', ' ', $attribs['dropzone']);
            //$attribs['multiple'] = 'multiple';
            $attribs['size'] = '3';
            $attribs['style'] = "float:left;margin-bottom:10px;";
            $buttons  = '<button class="si_notrack" type="button" onclick="simploo.gui.chooser(\''.$mode.'\', null, function(uid, title){ simploo.gui.addOption($(\'#'.self::IDPREFIX.$id.'_show\'), uid, title); $(\'#'.self::IDPREFIX.$id.'_show\').mouseout(); });"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_folder.gif').'" /></button>';
            $buttons .= '<button type="button" onclick="simploo.gui.removeDropElement(\''.self::IDPREFIX.$id.'_show\'); " class="si_notrack '.self::IDPREFIX.$id.'_show_onlysel" disabled="disabled"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_delete.gif').'" /></button><br/>';
            $buttons .= '<button type="button" onclick="simploo.gui.upDropElement(\''.self::IDPREFIX.$id.'_show\'); " class="si_notrack '.self::IDPREFIX.$id.'_show_onlysel" disabled="disabled"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_up.gif').'" /></button>';
            $buttons .= '<button type="button" onclick="simploo.gui.downDropElement(\''.self::IDPREFIX.$id.'_show\'); " class="si_notrack '.self::IDPREFIX.$id.'_show_onlysel" disabled="disabled"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_down.gif').'" /></button>'; 
        }else{
            $attribs['class'] =  "si_drop si_singledrop ".str_replace(',', ' ', $attribs['dropzone']);    
            $attribs['size'] = '1';
            $attribs['multiple'] = 'multiple';
            $attribs['style'] = "float:left;margin-bottom:10px;";  
            $buttons  = '<button class="si_notrack" type="button" onclick="simploo.gui.chooser(\''.$mode.'\', null, function(uid, title){ simploo.gui.addOption($(\'#'.self::IDPREFIX.$id.'_show\'), uid, title); $(\'#'.self::IDPREFIX.$id.'_show\').mouseout(); })"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_folder.gif').'" /></button>';
            $buttons .= '<button type="button" onclick="simploo.gui.removeDropElement(\''.self::IDPREFIX.$id.'_show\'); " class="si_notrack '.self::IDPREFIX.$id.'_show_onlysel" disabled="disabled"><img name="" id="" src="'.$this->view->backendLayout('_img/icon_drop_delete.gif').'" /></button>'; 
        }
        
        $form = $this->view->formHidden($id, $value, array('id' => $attribs['id']));  
        $attribs['id'] = $attribs['id']."_show";
        $form .= $this->view->formSelect($id."_show", $value, $attribs, $options);
        $form .= '<div style="width:auto;float:left;margin-bottom:10px;margin-left:5px;" class="si_dropbutton">'.$buttons.'</div><br style="clear:both;"/>';
        return $form;
    }
}