<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo_Lib
 * @package    Default
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Pack.php 1241 2010-03-15 19:33:52Z ms $
 */
class Simploo_Pack{
    
    private $_content  = '';
    private $_exclude  = array(); 
    const   SEPERATOR1 = '^^^^^';
    const   SEPERATOR2 = '%%%%%';
    
    public function __construct($exclude = array())
    {
        $this->_exclude = $exclude;    
    }
    
    public function archive($absoluteDirPath, $toFile)
    {
        $this->_content = '';
        $this->_archiveDir($absoluteDirPath);
        if(!$this->_content) return false;
        
        return @file_put_contents($toFile, $this->_content);    
    }
    
    private function _archiveDir($absoluteDirPath, $relativeDirPath = '')
    {
        if(!is_dir($absoluteDirPath)) return;
        
        $iterator = new DirectoryIterator($absoluteDirPath);
        foreach ($iterator as $fileinfo){
            if($fileinfo->getFilename() == '.' || $fileinfo->getFilename() == '..') continue; 
            if(in_array($fileinfo->getFilename(), $this->_exclude)) continue;
            if(is_dir($fileinfo->getPathname())){
                $this->_content .= self::SEPERATOR1.'d';
                $this->_content .= self::SEPERATOR2.$relativeDirPath.$fileinfo->getFilename();
                $this->_archiveDir($fileinfo->getPathname(), $relativeDirPath.$fileinfo->getFilename().'/'); 
            }else{
                $this->_content .= self::SEPERATOR1.'f';
                $this->_content .= self::SEPERATOR2.$relativeDirPath.$fileinfo->getFilename(); 
                $this->_content .= self::SEPERATOR2.file_get_contents($fileinfo->getPathname()); 
            } 
        }
        
        return;
    }
    
    public function extract($archiveFile, $toDir)
    {
        if(!is_dir($toDir) || !file_exists($archiveFile)) return false;
        
        $content = file_get_contents($archiveFile);
        $entries = explode(self::SEPERATOR1, $content);
        $files   = array();
        foreach($entries as $entry){
            $parts = explode(self::SEPERATOR2, $entry);
            if($parts[0] == 'f'){
                $files[] = array('name' => $parts[1], 'content' => $parts[2]);
            }
            if($parts[0] == 'd'){
                @mkdir($toDir.'/'.$parts[1]);
            }
        }
        foreach($files as $file){
            file_put_contents($toDir.'/'.$file['name'], $file['content']); 
        }
    }

}